SystemOrganization addCategory: #'GBT-DSL_GC_Things'!

Object subclass: #GCActiveServiceMasterData
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_GC_Things'!

!GCActiveServiceMasterData commentStamp: 'CC 8/6/2015 23:52' prior: 0!
I represent all master data of an active service.!

!GCActiveServiceMasterData class methodsFor: 'asvo-company master data' stamp: 'hk 5/2/2017 16:47'!
activeServiceMasterData
	"self activeServiceMasterData edit"
	"ActiveService master data structure is basic for any AS. It is deployed with predefined configuration values."
	
	^GbtSmartThing struct: 'GCActiveServiceMasterData' define: {
 	} full: {  
		{ #templates .  #thing: . GCBizStructures templates }.
		{ #masterData .  #thing: . GCMasterData masterData}.
		{ #logisticsBizData .  #thing: . GCLogisticsBizData  logisticsBizData}.		
		{ #userSettings .  #thing: . GCUserSettings  userSettings}.		
		{ #managementInformation .  #thing: . GCManagementInformation managementInformation}.	
	}! !

GCActiveServiceMasterData subclass: #GCBizStructures
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_GC_Things'!

!GCBizStructures commentStamp: 'CC 7/30/2015 18:43' prior: 0!
I categorize application templates which drive the functionality of an ActiveService!

GCBizStructures subclass: #GCBizAspectItems
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_GC_Things'!

!GCBizAspectItems commentStamp: 'hk 8/4/2015 14:18' prior: 0!
CC 8/4/2015 12:31
Offer and Order are essentials of  a biz process.!

!GCBizAspectItems class methodsFor: 'asvo-company master data' stamp: 'hk 5/2/2017 16:47'!
activitiesTemplate
	"self activitiesTemplate edit"

	^GbtSmartThing struct: 'GCActivitiesTemplate ' define: { 
		{ #activitiesTemplateIdentity . #val: . 'activities template identity' }.		
 	} full: {  
		{ #activities . #thing: . self activities }.				
	}
! !

!GCBizAspectItems class methodsFor: 'asvo-activities' stamp: 'hk 5/2/2017 16:47'!
activity
	"self activityX edit"
	
	^GbtSmartThing struct: 'GCActivity' define: {
		{ #purposes . #(activity) }.
		{ #idNumberPolicy . #GCDefaultPolicy }.
		{ #summary . 'price --  #price '}.
		{ #activityDescription . #text: . 'activity description' }.
		{ #activityNote . #text: . 'note' }.
		{ #qty . #no:from:to: . 0 . 0 . 1 }.
		{ #priceUnit . #enum: . GCCommons enumPriceUnits }.
		{ #pricePerUnit . #no:from:to: . 0 . 0 . nil  }. "calculatedPrice"
		{ #price . #calc: . ' #qty * #pricePerUnit ' }.
		{ #variablePrice .#no:from:to: . 0 . 0 .nil }.
		{ #currency . #enum: . GCCommons gcCurrency }.
		{ #supplierPricing . #val: . 'supplier price items' }.
		{ #tariff . #val: . 'GCBizId#GCTariff' }.
		{ #relatedAspects . #val: . 'related offer order task order billables' }.
		{ #housePrice . #thing: . GCCommons gcMonetaryValue }.
		{ #activityServiceData . #thing: . GCServiceData serviceData}.		
 	} full: {  
		{ #activityStatusDescriptor . #thing: . self activityStatusDescriptor }.
		{ #activityMgmt . #thing: . self activityMgmt }.
	}






! !

!GCBizAspectItems class methodsFor: 'asvo-activities' stamp: 'hk 5/2/2017 16:47'!
activityMgmt
	"self activityMgmt edit"
	
	^GbtSmartThing struct: 'GCActivityMgmt' define: {
		{ #summary . 'owner: #activityOwner start: #activityStart due: #activityDue'}.
		{ #activityOwner . #thing: . GCContact staffPerson  }.
		{ #activityStart . #thing: . GCCommons gcDate }.		
		{ #activityDue . #thing: . GCCommons gcDate }.				
 	} full: {  
	}

! !

!GCBizAspectItems class methodsFor: 'asvo-activities' stamp: 'hk 5/2/2017 16:47'!
activityStatusDescriptor
	"self activityStatusDescriptor edit"
	
	^GbtSmartThing struct: 'GCActivityStatusDescriptor' define: {
		{ #summary . 'status: #activityStatus tOStatus: #activityTaskOrderStatus dispatchType: #activityTaskOrderDispatchType cat: #activityCategory'}.
		{ #activityStatus . #enum: . #(tbd request planned offer allocated  order started complete completeWithChange) }.
		{ #activityTaskOrderStatus . #enum: . #(tbd request plannedOrOffered allocatedOrOrdered started complete changed) }.		
		{ #activityTaskOrderDispatchType . #enum: . #(internalService externalService anyService) }.				
				{ #activityCategory . #enum: . #(roadTransport, modalTransport, projectService, generalService) }.	
 	} full: {  
	}! !

!GCBizAspectItems class methodsFor: 'asvo-contract' stamp: 'hk 5/2/2017 16:47'!
associatedSupplierContractItem
	"self associatedSupplierContractItem editD"
	
	^GbtSmartThing struct: 'GCAssociatedSupplierContractItem' define: { 
		{ #supplierContractItemData . #val: . 'supplier contract item bizId and data' }.
 	} full: {  
	}
	
! !

!GCBizAspectItems class methodsFor: 'asvo-company master data' stamp: 'hk 5/2/2017 16:47'!
bizAspectItems
	"self bizAspectItems edit"

	^GbtSmartThing struct: 'GCBizAspectItems ' define: { 
		{ #bizContractItem . #listOf: . self bizContractItem }.
		{ #priceItem . #listOf: . self contractPriceItem }.
		{ #activityTemplates . #listOf: . self activity }.					
 	} full: {  
	}
! !

!GCBizAspectItems class methodsFor: 'asvo-contract' stamp: 'hk 5/2/2017 16:47'!
bizContractItem
	"self bizContractItem editD"
	
	^GbtSmartThing struct: 'GCBizContractItem' define: { 
		{ #purposes . #(bizOffer bizOrder) }.
		{ #idNumberPolicy . '#GCAlphaPolicy' }.
		{ #summary . '#contractItemDescription' }.
		{ #contractItemHeader . #thing: . self contractItemHeader }.
		{ #contractPriceItems . #listOf: . self contractPriceItem }.
		{ #contractPriceTotals . #listOf: . self contractPriceTotals}.
		{ #contractItemDetails . #thing: . self contractItemDetails}.
		{ #contractPrivateItemDetails . #thing: . self contractPrivateItemDetails }.			
		{ #associatedSupplierContractItems . #listOf: . self associatedSupplierContractItem}.
 	} full: {  
	}
	
! !

!GCBizAspectItems class methodsFor: 'asvo-company master data' stamp: 'hk 5/2/2017 16:47'!
bizTemplates
	"self bizTemplates edit"

	^GbtSmartThing struct: 'GCBizTemplates ' define: { 
		{ #bizDataItemsTemplates . #listOf: . self bizDataItemTemplate }.
		{ #activitiesTemplates . #listOf: . self activitiesTemplate }.					
 	} full: {  
	}
! !

!GCBizAspectItems class methodsFor: 'asvo-contract' stamp: 'hk 5/2/2017 16:47'!
contractItemDetails
	"self contractItemDetails editD"
	
	^GbtSmartThing struct: 'GCContractItemDetails' define: { 

		{ #contractCurrency . #enum: . GCCommons gcCurrency }.
		{ #paymentTerms . #val: . 'payment terms' }.
		{ #currencyConversionRates . #listOf: . self currencyConversion}.
		{ #itemNote . #text: . 'item note'}.
		{ #houseCurrencyRef . #calc: . 'ref #houseCurrency' }.
 	} full: {  
	}


! !

!GCBizAspectItems class methodsFor: 'asvo-contract' stamp: 'hk 5/2/2017 16:47'!
contractItemHeader
	"self contractItemHeader editD"
	
	^GbtSmartThing struct: 'GCContractItemHeader' define: { 
		{ #summary . '#contractItemDescription' }.
		{ #contractItemDescription . #calc: . 'ref Item #bizId' }. "referencing the contract item bizId"
		{ #contractItemValidity . #thing: . GCCommons gcValidity }.
		{ #serviceData . #thing: . GCServiceData serviceData}.
		{ #revenues . #calc: . 'ref #houseCurrencyTotals'}.
		{ #fulfilmentStart . #thing: . GCCommons gcDate }.			
 	} full: {  
	}

! !

!GCBizAspectItems class methodsFor: 'asvo-contract' stamp: 'hk 5/2/2017 16:47'!
contractPriceItem
	"self contractPriceItem editD"

	^GbtSmartThing struct: 'GCContractPriceItem' define: { 
		{ #purposes . #(bizPriceItem) }.
		{ #idNumberPolicy . #GCDefaultPolicy }.
		{ #summary . 'price --  #price '}.
		{ #priceItemDescription . #text: . 'price item description' }.
		{ #priceItemNote . #text: . 'note' }.
		{ #qty . #no:from:to: . 0 . 0 . 1 }.
		{ #priceUnit . #enum: . GCCommons enumPriceUnits }.
		{ #pricePerUnit . #no:from:to: . 0 . 0 . nil  }. "calculatedPrice"
		{ #price . #calc: . ' #qty * #pricePerUnit ' }.
		{ #variablePrice .#no:from:to: . 0 . 0 .nil }.
		{ #currency . #enum: . GCCommons gcCurrency }.
		{ #serviceParameters . #calc: . 'ref ' }.
		{ #tariff . #val: . 'GCBizId#GCTariff' }.
		{ #activities . #val: . 'GCActivityBizId listOf: #GCActivity' }.
		{ #housePrice . #thing: . GCCommons gcMonetaryValue }.
		{ #taxCode . #val: . 'GCTaxCode#GCBusinessDomain#TaxCodes' }.		
 	} full: {  
	}
	


! !

!GCBizAspectItems class methodsFor: 'asvo-contract' stamp: 'hk 5/2/2017 16:47'!
contractPriceTotals
	"self contractPriceTotals editD"
	
	^GbtSmartThing struct: 'GCContractPriceTotals ' define: { 
		{ #priceTotals . #calc: . 'sum #price' }.	
		{ #variablePriceTotals . #calc: . 'sum #variablePrice'}.
		{ #housePriceTotals . #calc: . 'sum  #housePrice '}.
 	} full: {  
	}
	
! !

!GCBizAspectItems class methodsFor: 'asvo-contract' stamp: 'hk 5/2/2017 16:47'!
contractPrivateItemDetails
	"self contractPrivateItemDetails editD"
	
	^GbtSmartThing struct: 'GCContractPrivateItemDetails' define: { 
		{ #tariff . #val: . 'GCTariffBizId'  }.
		{ #bizMargin . #thing: . GCCommons gcMonetaryValue }.
		{ #houseCurrency . #enum: . GCCommons gcCurrency}.
 	} full: {  
	}


! !

!GCBizAspectItems class methodsFor: 'asvo-contract' stamp: 'hk 5/2/2017 16:47'!
currencyConversion
	"self currencyConversion editD"
	
	^GbtSmartThing struct: 'GCCurrencyConversion' define: { 
			{ #purposes . #(currencyConversion) }.
		{ #summary . '#otherCurrency to #houseCurrency : #currencyConversionRate'}.	
		{ #currencyConversionRate . #no: . 1.0 }.
		{ #otherCurrency . #enum: . GCCommons gcCurrency }.
		{ #dateOfValidity . #thing: . GCCommons gcDate }.
 	} full: {  
	}

! !

!GCBizStructures class methodsFor: 'asvo-company master data' stamp: 'hk 5/2/2017 16:47'!
templates
	"self templates edit"
	"templates are application templates used in biz processes and elsewhere."
	"They come predefined as master application templates and are refined by users."
	
	^GbtSmartThing struct: 'GCTemplates' define: {
		{ #serviceDataTemplates .  #thing: . GCServiceData serviceData }.
		{ #bizTemplates .  #thing: . GCBizAspectItems bizAspectItems}.
		{ #tariffTemplates .  #thing: . GCTariffs  tariffs}.		
		{ #taskTemplates .  #thing: . GCTaskStructures  tasks}.
  	} full: {  
	}! !

GCBizStructures subclass: #GCDeliveryUnit
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_GC_Things'!

GCBizStructures subclass: #GCServiceData
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_GC_Things'!

!GCServiceData commentStamp: 'CC 1/21/2016 20:31' prior: 0!
CC 8/3/2015 17:06
I define service data structure in its most encompassing version.

Service data is used in all GC aspects in some way.

Service data has a history from where is has been created. Over time, it is extended by data up to delivery data. The history can be used to find differences of data along the process chain, e.g. differences between ordered shipment items and actually transported shipment items. 



!

!GCServiceData class methodsFor: 'asvo-helpers' stamp: 'cc 7/29/2015 16:59'!
averageLoadingTime

	^(Duration minutes: 30)minutes printString! !

!GCServiceData class methodsFor: 'asvo-serviceData' stamp: 'hk 5/2/2017 16:47'!
bizNote
	"self bizNote edit"

	^GbtSmartThing struct: 'GCBizNote' define: {
	{ #purposes . #(local shared)}.
	{ #summary . '#textNote' }.
	{ #textNote . #text: . 'biz note' }.	
	{ #paymentTerms . #text: . 'payment terms'}	
 	} full: {  
	}








! !

!GCServiceData class methodsFor: 'asvo-service data item transport' stamp: 'hk 5/2/2017 16:47'!
customerDetails
	"self customerDetails edit"

	^GbtSmartThing struct: 'GCCustomerDetails' define: {
		{ #purposes . #(customerDetails)}.
		{ #summary . '#customerNotification' }.
		{ #customerNotification . #val: . 'eMail: #eMail phone: #phoneNo' }.
 	} full: {  
		{ #deliveryDetails . #val: . 'days: saturdays time: timeslot' }.
		{ #customerPayment . #enum: . #(creditCard moneyTransfer)}.
		{ #paymentTerms . #val: . '0 days' }.
	}

! !

!GCServiceData class methodsFor: 'asvo-shipmentRouteAndDate' stamp: 'hk 5/2/2017 16:47'!
deliveryLocation
	"self deliveryLocation edit"

	^GbtSmartThing struct: 'GCDeliveryLocation' define: {
		{ #summary . '#destination'}.
		{ #destination . #thing: . self transportLocation}.
	} full: { 
		{ #incoTermsAtDestination . #enum: . GCCommons enumIncoTerms }.
		{ #specifalTermsAndConditionsAtDestination . #enum: . GCCommons enumTermsAndConditions }.
		{ #deliveryInfo . #text: . 'delivery info'}.
		{ #pickupReference . #val: . 'pickup reference'}.
	}





! !

!GCServiceData class methodsFor: 'asvo-serviceData' stamp: 'hk 5/2/2017 16:47'!
deliveryNote
	"self deliveryNote edit"

	^GbtSmartThing struct: 'GCDeliveryNote' define: {
	{ #purposes . #(local shared)}.
	{ #summary . '#textNote' }.
	{ #textNote . #text: . 'delivery note' }.	
	{ #deliveryNote . #text: . 'delivery information'}	
 	} full: {  
	}











! !

!GCServiceData class methodsFor: 'asvo-serviceData' stamp: 'hk 5/2/2017 16:47'!
documentNote
	"self documentNote edit"

	^GbtSmartThing struct: 'GCDocumentNote' define: {
	{ #purposes . #(local shared)}.
	{ #summary . '#textNote' }.
	{ #textNote . #text:. 'document note' }.	
	{ #documentNote . #text: . 'a GCDocumentTemplate'}	
 	} full: {  
	}









! !

!GCServiceData class methodsFor: 'asvo-enums' stamp: 'CC 11/29/2015 13:52'!
enumGoods
	"comment stating purpose of message"

	^#(commodity food machinery commercialMisc)! !

!GCServiceData class methodsFor: 'asvo-enums' stamp: 'cc 7/28/2015 20:15'!
enumItemClassification
	"classifications may be added by user"

	^#(class1 class2 class3)! !

!GCServiceData class methodsFor: 'asvo-enums' stamp: 'cc 7/28/2015 20:03'!
enumMeansOfTransport

	^#(TrailerTruck Train Ship Plane Barge)
! !

!GCServiceData class methodsFor: 'asvo-enums' stamp: 'CC 11/29/2015 13:51'!
enumPacking
	"comment stating purpose of message"

	^#(palette box crate piece can unpacked)! !

!GCServiceData class methodsFor: 'asvo-enums' stamp: 'cc 7/28/2015 20:56'!
enumProjectCategory
	"comment stating purpose of message"

	^#(projectService generalService)! !

!GCServiceData class methodsFor: 'asvo-enums' stamp: 'cc 7/29/2015 15:17'!
enumServiceDocumentType
	"comment stating purpose of message"

	^#(wayBill pickupDoc deliveryDoc packingList consolidationDoc)! !

!GCServiceData class methodsFor: 'asvo-enums' stamp: 'cc 7/28/2015 20:03'!
enumServiceFrequency
	""

	^#(oneTime weekly monthly periodic)! !

!GCServiceData class methodsFor: 'asvo-enums' stamp: 'CC 1/26/2016 11:01'!
enumShipmentMode
	"comment stating purpose of message"

	^#(ltl ftl container parcel modal ltlOrFtl express)! !

!GCServiceData class methodsFor: 'asvo-shipmentgoods' stamp: 'hk 5/2/2017 16:47'!
hazardousCargo
	"elementary asvo"

	^GbtSmartThing struct: 'GCHazardousCargo' define: {  
	{ #imo_Declaration . #text: . ''}.
	{ #limitedquantities_eq . #text: . ''}.
 	} full: {  
	}! !

!GCServiceData class methodsFor: 'asvo-service data item transport' stamp: 'hk 5/2/2017 16:47'!
insurance
	"self insurance edit"

	^GbtSmartThing struct: 'GCInsurance' define: { 
		{ #purposes . #(insurance)}.
		{ #summary . ''}.
		{ #applicable . #enum: . #(no yes) }.
 	} full: {
		{ #insuredValue . #thing: . GCCommons gcMonetaryValue }.
	}
 

! !

!GCServiceData class methodsFor: 'asvo-shipmentgoods' stamp: 'hk 5/2/2017 16:47'!
labelsMarksAndNumbers
	"self shipmentGoodsItemContents editD"

	^GbtSmartThing struct: 'GCLabelsMarksAndNumbers' define: {
	{ #purposes . #(labels) }.
	{ #summary . '#labelsMarksAndNumbers' }.
	{ #labelsMarksAndNumbers . #text: . 'labels marks and numbers' }.
	} full: { 
	}







! !

!GCServiceData class methodsFor: 'asvo-service data item transport' stamp: 'hk 5/2/2017 16:47'!
loadingDeviceExchange
	"self loadingDeviceExchange editD"

	^GbtSmartThing struct: 'GCLoadingDeviceExchange' define: {
		{ #purposes . #(paletteExchange crateExchange)}.
		{ #summary . '#exchangeMode' }.
		{ #exchangeMode . #enum: . GCCommons enumLoadingDeviceExchangeMode }.
 	} full: {  
		{ #lodadingDevicesDelivered . #listOf: . self loadingDeviceLot }.
		{ #loadingDevicesReceived . #listOf: . self loadingDeviceLot }.
	}





! !

!GCServiceData class methodsFor: 'asvo-service data item transport' stamp: 'hk 5/2/2017 16:47'!
loadingDeviceLot
	"self loadingDeviceLot edit"

	^GbtSmartThing struct: 'GCLoadingDeviceLot' define: { 
		{ #purposes . GCCommons enumLoadingDevices  }.	
		{ #summary . 'qyt #qty quality #quality' }.
		{ #qty . #no: . '0' }.
		{ #quality . #enum: . GCCommons enumLoadingDeviceQuality}.
 	} full: {  
	}



! !

!GCServiceData class methodsFor: 'asvo-shipmentRouteAndDate' stamp: 'hk 5/2/2017 16:47'!
loadingTime
	"self loadingTime edit"

	^GbtSmartThing struct: 'GCLoadingTime' define: {
		{ #purposes . #(loadingTime unloadingTime)}.
		{ #summary . '#purposes time: #loadingTime'}.
		{ #loadingTime . #val: . (Duration minutes: 30)minutes printString}.
 	} full: {  
	}
! !

!GCServiceData class methodsFor: 'asvo-shipmentRouteAndDate' stamp: 'hk 5/2/2017 16:47'!
locationNote
	"self locationNote edit"

	^GbtSmartThing struct: 'GCLocationNote' define: {
		{ #purposes . #(locationNote)}.
		{ #locationNote . #text: . 'a location note'}.
	} full: { 
	}





! !

!GCServiceData class methodsFor: 'asvo-shipmentgoods' stamp: 'hk 5/2/2017 16:47'!
packingList
	"self packingList edit"

	^GbtSmartThing struct: 'GCPackingList' define: { 
	{ #purposes . #(packingList)}.
	{ #summary . 'packing list' }.
	{ #packingList . #text: . 'here we start anogher shipmentGoods list recursively' }
	}
	full: {
	}! !

!GCServiceData class methodsFor: 'asvo-shipmentgoods' stamp: 'hk 5/2/2017 16:47'!
packingListStatistics
	"self packingListStatistics edit"

	^GbtSmartThing struct: 'GCPackingListStatistics' define: {
		{ #purpose . #packingListStatistics}.
		{ #summary . 'packing list statistics' }}
	full: { 
		{ #packingListStatistics . #val: . 'packing list statistics' }.
 	} ! !

!GCServiceData class methodsFor: 'asvo-shipment' stamp: 'hk 5/2/2017 16:47'!
pickupDeliveryContact
	"self pickupDeliveryContact edit"

	^GbtSmartThing struct: 'GCPickupDeliveryContact' define: {
		{ #summary . 'contact person: #personName'}.
		{ #personName . #val: . ''}.
		{ #phoneNo . #val: . ''}.
 	} full: { 
		{ #contactSpecifics . #text: . 'specifics'}.
		{ #companyName . #val: . ''}. 
		{ #role . #val: . ''}.
	}

! !

!GCServiceData class methodsFor: 'asvo-service data item transport' stamp: 'hk 5/2/2017 16:47'!
pickupDoc
	"self pickupDocX edit"

	^GbtSmartThing struct: 'GCPickupDoc' define: { 
		{ #purpose . #pickupDocument }.
		{ #summary . '#purpose #pickupDocument' }.
		{ #pickupDocument . #thing: . GCCommons textNote}.
 	} full: {  
	}






! !

!GCServiceData class methodsFor: 'asvo-shipmentRouteAndDate' stamp: 'hk 5/2/2017 16:47'!
pickupLocation
	"self pickupLocation edit"

	^GbtSmartThing struct: 'GCPickupLocation' define: {
		{ #summary . '#origin'}.
		{ #origin . #thing: . self transportLocation}.
	} full: { 
		{ #incoTermsAtOrigin . #enum: . GCCommons enumIncoTerms }.
		{ #specifalTermsAndConditionsAtOrigin . #enum: . GCCommons enumTermsAndConditions }.
		{ #pickupInfo . #text: . 'pickup info'}.
		{ #pickupReference . #val: . 'pickup reference'}.
	}





! !

!GCServiceData class methodsFor: 'asvo-service data item project' stamp: 'hk 5/2/2017 16:47'!
projectData
	"self projectData edit"

	^GbtSmartThing struct: 'GCProjectData' define: { 
		{ #projectCategory . #enum: . self enumProjectCategory  }.
		{ #serviceParameters . #listOf: . self serviceParameter}. 
		{ #projectIssues. #listOf: . self projectIssue }.
		{ #summary . ' #projectIssue #projectIssueDescription #projectIssueQuantity #projectIssueQuantityUnit' }.
 	} full: {  
	}


! !

!GCServiceData class methodsFor: 'asvo-service data item project' stamp: 'hk 5/2/2017 16:47'!
projectIssue
	"self projectIssue edit"

	^GbtSmartThing struct: 'GCProjectIssue' define: { 
	 	{ #summary . ' #taskDescription ' }.
		{ #taskDescription . #val: . '' }.
		{ #projectIssueParameters . #enum: . GCCommons enumProjectParameters   }.
	} full: {  
		{ #effort . #thing: . self serviceParameter }.
		{ #skill . #thing: . self serviceParameter  }.
 	}








! !

!GCServiceData class methodsFor: 'asvo-service data item project' stamp: 'hk 5/2/2017 16:47'!
projectServiceItem
	"self projectServiceItem edit"

	^GbtSmartThing struct: 'GCProjectServiceItem' define: { 
	{ #itemType . #val: . #projectService }.
	{ #itemNumber . #val: . ''}.
	{ #itemClassification. #enum: . self enumItemClassification }.
	{ #itemShortName . #val: . 'a project service item'}.
	{ #itemDescription . #val: . ''}.
	{ #projectData . #thing: . self projectData}.
	{ #serviceFrequency . #enum: . self enumServiceFrequency}.
	"{ #serviceActivationSchedule . #thing: . self activationSchedule} "
	{ #summary . '#projectData ' }.
 	} full: {  
	}
! !

!GCServiceData class methodsFor: 'asvo-serviceData' stamp: 'hk 5/2/2017 16:47'!
serviceData
	"self serviceData editD"
	
	^GbtSmartThing struct: 'GCServiceData' define: { 
		{ #purposes . #(serviceData) }.
		{ #idNumberPolicy . #GCServiceDataNoPolicy }.
		{ #widgetClassName . #GbtCustomSDBoxWidget }.
		{ #summary . '#serviceDataItems ' }.
		{ #serviceDataHeader . #thing: . self serviceDataHeader }.
		{ #serviceDataItems . #listOf: . {self serviceDataItemTransport ".self serviceDataItemProject . self serviceDataItemGeneral"}}.
		{ #serviceDataNotes . #listOf: . {self serviceDataNote . self bizNote . self tourNote . self documentNote . self deliveryNote}}.
 	} full: {  
	}! !

!GCServiceData class methodsFor: 'asvo-serviceData' stamp: 'hk 5/2/2017 16:47'!
serviceDataHeader
	"self serviceDataHeader editD"
	
	^GbtSmartThing struct: 'GCServiceDataHeader' define: { 
		{ #serviceDataHeaderLabel . #val: . 'Service Data ' }.
		{ #summary . '#path ( #root #summary )' }.
		{  #aspectStatus . #enum: . #(bizProcess request offer order orderAcknowldegment billableItems taskOrder) }.
 	} full: {  
	}! !

!GCServiceData class methodsFor: 'asvo-service data item transport' stamp: 'hk 5/2/2017 16:47'!
serviceDataItemTransport
	"self serviceDataItemTransport editD"

	^GbtSmartThing struct: 'GCServiceDataItemTransport' define: { 
	{ #purposes . #(roadTransport modalTransport) }.
	{ #idNumberPolicy . #GCDefaultPolicy }.
	{ #summary . '#shipmentRoute / #pickupDateAndTime:handlingDate / #shipmentGoodsItems' }.
	{ #serviceDataItemTransportHeader . #thing: . self serviceDataItemTransportHeader }.
	{ #shipment . #thing: . self shipment }.
	{ #shipmentRemarks . #text: . '' }.
	}
	full: {
	{ #shipmentRelatedService . #thing: .  self insurance }.
	{ #customerDetails . #thing: . self customerDetails }.
	{ #transportMeans . #listOf: . {self loadingDeviceExchange . self vehicleMeans  ". self shippingLineMeans . self airlineMeans. self modalMeans" }}.
	{ #shipmentDocuments . #listOf: . self shipmentDocuments}.
	{ #partiesAndRoles . #listOf: . self transportRole}
 	}





 ! !

!GCServiceData class methodsFor: 'asvo-service data item transport' stamp: 'hk 5/2/2017 16:47'!
serviceDataItemTransportHeader
	"self serviceDataItemTransportHeader editD"
	
	^GbtSmartThing struct: 'GCServiceDataItemTransportHeader' define: { 
		{ #summary . 'MODE #shipmentMode PREFERENCE #fulfillmentPreference' }.
		{ #serviceDataItemTransportHeaderLabel . #val: . 'Transport' }.
		{ #serviceDataItemNo . #val: . 'Item x' }.
		{ #shipmentMode . #enum: . self enumShipmentMode }. "#(ftl ltl container parcel modal ltlOrFtl express)"
		{ #fulfillmentPreference . #enum: . #(supplierShipment supplierTransport internalTransport internalShipment)}.

 	} full: { 
		{ #shipmentFrequency . #thing: . self shipmentFrequency }. 
	}! !

!GCServiceData class methodsFor: 'asvo-serviceData' stamp: 'hk 5/2/2017 16:47'!
serviceDataNote
	"self serviceDataNote edit"

	^GbtSmartThing struct: 'GCServiceDataNote' define: {
	{ #purposes . #(local shared)}.
	{ #summary . '#textNote' }.
	{ #textNote . #text: . 'service data note' }.	
 	} full: {  
	}







! !

!GCServiceData class methodsFor: 'asvo-company master data' stamp: 'hk 5/2/2017 16:47'!
serviceDataTemplates
	"self serviceDataTemplates edit"

	^GbtSmartThing struct: 'GCServiceDataTemplates' define: { 
		{ #serviceDataTemplateList . #listOf: . self serviceData }.
 	} full: {  
	}
! !

!GCServiceData class methodsFor: 'asvo-serviceData' stamp: 'hk 5/2/2017 16:47'!
serviceParameter
	"self serviceParameter edit"
	
	^GbtSmartThing struct: 'GCServiceParameter' define: { 
		{ #purposes . #(#parameterName) }.
		{ #summary . '#parameterGroup / #parameterName / #parameterUnit / #parameterValue' }.
		{ #parameterGroup . #enum: . GCCommons enumParameterGroups }.
		{ #parameterName . #enum: . GCCommons enumBaseParameters }.
		{ #parameterUnit . #enum: . GCCommons enumBaseParameterUnits }. 
		{ #parameterValue . #val: . ''}.
 	} full: {  
	}! !

!GCServiceData class methodsFor: 'asvo-shipment' stamp: 'hk 5/2/2017 16:47'!
shipment
	"self shipment editD"

	^GbtSmartThing struct: 'GCShipment' define: { 
	{ #idNumberPolicy . #GCDefaultPolicy }.
	{ #summary . ' 	#shipmentRoute / #shipmentDates / #shipmentGoods / #shipmentWeight' }.
	{ #shipmentRouteAndDate . #thing: . self shipmentRouteAndDate }.
	{ #shipmentGoods . #thing: . self shipmentGoods }.
	{ #shipmentRemarks . #text: . 'Shipment Remarks' }.
	{ #shipmentWeight . #calc:tag: . 'sum #spShipmentGoodsWeight' . #spShipmentWeight}
	}
	full: { 
	}
! !

!GCServiceData class methodsFor: 'asvo-shipmentgoods' stamp: 'hk 5/2/2017 16:47'!
shipmentContentsPackingList 
	"self shipmentContentsPackingList edit"

	^GbtSmartThing struct: 'GCShipmentContentsPackingList' define: {
		{ #purpose . #packingList}.
		{ #summary . '#packingList' }.
		{ #packingList . #thing: . self containedShipment }.
		{ #statistics . #thing: . self packingListStatistics}.
 	} full: {  
	}
! !

!GCServiceData class methodsFor: 'asvo-shipmentRouteAndDate' stamp: 'hk 5/2/2017 16:47'!
shipmentDates
	"self shipmentDates editD"

	^GbtSmartThing struct: 'GCShipmentDates' define: {
		{ #purposes . #(shipmentDates)}.
		{ #summary . '#pickupDateAndTime delivery #deliveryDateAndTime' }.
		{ #pickupDateAndTime . #thing: . self shipmentHandlingDateAndTime }.
		{ #deliveryDateAndTime. #thing: . self shipmentHandlingDateAndTime }.
 	} full: {  
		{ #pickupWait. #thing: . GCCommons gcTime }.
		{ #deliveryWait. #thing: . GCCommons gcTime }.
	}
! !

!GCServiceData class methodsFor: 'asvo-service data item transport' stamp: 'hk 5/2/2017 16:47'!
shipmentDocuments
	"self shipmentDocuments edit"

	^GbtSmartThing struct: 'GCShipmentDocuments' define: {
		{ #purposes . GCCommons enumShipmentDocuments}.
		{ #summary . '#documentNote' }.
		{ #documentNote . #text: . 'name.pdf and note'}.
		{ #documentLink . #val: . 'documentLink'  }.
	} full: {  
	}
! !

!GCServiceData class methodsFor: 'asvo-service data item transport' stamp: 'hk 5/2/2017 16:47'!
shipmentFrequency
	"self shipmentFrequency editD"

	^GbtSmartThing struct: 'GCShipmentFrequency' define: {
		{ #purposes . #(repeatedShipment)}.
		{ #summary . 'Frequency #frequencyOfService' }.
		{ #frequencyOfService . #enum: . GCCommons enumShipmentFrequency }.
 	} full: {  
		{ #calendarDates . #thing: . GCCommons gcCalendar}.
	}

! !

!GCServiceData class methodsFor: 'asvo-shipmentgoods' stamp: 'hk 5/2/2017 16:47'!
shipmentGoods
	"self shipmentGoods editD"

	^GbtSmartThing struct: 'GCShipmentGoods' define: {
		{ #purpose . '#shipmentGoods' }.
		{ #summary . '#shipmentGoodsItems' }.
		{ #shipmentGoodsItemsHeader . #val: . 'ItemNo packing/loading qty weight/units dimensions/units content totals  weight totals volume'}.
		{ #shipmentGoodsItems . #listOf: . self shipmentGoodsItem }.
		{ #shipmentGoodsWeight . #calc:tag: . 'sum #spShipmentGoodsItemWeight' . #spShipmentGoodsWeight}.
	} full: { 
	}






! !

!GCServiceData class methodsFor: 'asvo-shipmentgoods' stamp: 'hk 5/2/2017 16:47'!
shipmentGoodsHazardousGoodsInfo
	"self shipmentGoodsHazardousGoodsInfo edit"

	^GbtSmartThing struct: 'GCShipmentGoodsHazardousGoodsInfo' define: {
		{ #purpose . #hazardousGoodsInfo}.
		{ #summary . '#imo_Declaration #limitedquantities_eq' }.
		{ #imo_Declaration . #val: . 'IMO_Declaration'  }.
		{ #limitedquantities_eq . #val: . 'LimitedQuantities'}.
 	} full: {  
	}
	






! !

!GCServiceData class methodsFor: 'asvo-shipmentgoods' stamp: 'hk 5/2/2017 16:47'!
shipmentGoodsItem
	"self shipmentGoodsItem editD"

	^GbtSmartThing struct: 'GCShipmentGoodsItem' define: {
		{ #purpose . #shipmentGoodsItem}.
		{ #idNumberPolicy . #GCDefaultPolicy }.
		{ #summary . '#packingQty #packing EACH #singleShipmentGoodsItemWeight / #singleShipmentGoodsItemVolume / #shipmentGoodsItemContents / total weight #shipmentGoodsItemWeight' }.
		{ #shipmentGoodsItemNo . #val: . '#bizId'}.
		{ #packingQty . #no: . 1}.
		{ #packing . #enum: . self enumPacking }.
		{ #singleShipmentGoodsItemWeight . #thing: . self singleShipmentGoodsItemWeight }.
		{ #singleShipmentGoodsItemVolume . #thing: . self singleShipmentGoodsItemVolume }.
		{ #shipmentGoodsItemContents . #thing: . self shipmentGoodsItemContents }.
	} full: { 
		{ #loadingProperties  . #enum: . #(stackable nonStackable) }.
		{ #shipmentGoodsItemWeight . #calc:tag: . ' #grossWeight * #packingQty' . #spShipmentGoodsItemWeight}.
		{ #shipmentGoodsItemVolume . #calc:tag: . ' #volume * #packingQty' .  #spShipmentGoodsItemVolume }.
		{ #volumeWeightFactor . #no: . GCCommons gcVolumeWeightFactor }.
		{ #volumeTotal . #calc: . ' #volumeWeight * #packingQty' }.
		{ #shipmentGoodsItemVolumeWeight . #calc: . '#packingQty * #volume / #volumeWeightFactor' }.
	}





! !

!GCServiceData class methodsFor: 'asvo-shipmentgoods' stamp: 'hk 5/2/2017 16:47'!
shipmentGoodsItemContents
	"self shipmentGoodsItemContents editD"

	^GbtSmartThing struct: 'GCShipmentGoodsItemContents' define: { 
	{ #summary . '#contentsDescription' }.
	{ #contentsDescription . #text: . 'contents description' }.
	}
	full: { 
	{ #contentsDescriptionDetails . #listOf: . { self labelsMarksAndNumbers . self packingListStatistics . self shipmentGoodsHazardousGoodsInfo . self packingList }}.
	{ #scopeOfService . #enum: . GCCommons enumScopeOfService}
	}






! !

!GCServiceData class methodsFor: 'asvo-shipmentRouteAndDate' stamp: 'hk 5/2/2017 16:47'!
shipmentHandlingDateAndTime
	"self shipmentHandlingDateAndTime edit"

	^GbtSmartThing struct: 'GCShipmentHandlingDateAndTime' define: {
		{ #purposes . #(shipmentDates)}.
		{ #summary . '#handlingDate , #startTime -> #endTime' }.
		{ #handlingDate . #date: . Date today printString }.
 	} full: {  
		{ #startTime. #thing: . GCCommons gcTime }.
		{ #endTime. #thing: . GCCommons gcTime }.
	}
! !

!GCServiceData class methodsFor: 'asvo-shipmentRouteAndDate' stamp: 'hk 5/2/2017 16:47'!
shipmentRoute
	"self shipmentRoute editD"

	^GbtSmartThing struct: 'GCShipmentRoute' define: {
		{ #purposes . #(route)}.
		{ #summary . '#pickupLocation:city -> #deliveryLocation:city' }.
		{ #pickupLocation . #thing: . self pickupLocation }.
		{ #deliveryLocation . #thing: . self deliveryLocation}.
	} full: { 
		{ #shipmentVia . #thing: . self transportLocation }.
	}
! !

!GCServiceData class methodsFor: 'asvo-shipmentRouteAndDate' stamp: 'hk 5/2/2017 16:47'!
shipmentRouteAndDate
	"self shipmentRouteAndDate editD"

	^GbtSmartThing struct: 'GCShipmentRouteAndDate' define: {
		{ #summary . '#shipmentRoute / #pickupDateAndTime:handlingDate / #shipmentRouteAndDateHeader'}.
		{ #shipmentRouteAndDateHeader . #thing: . self shipmentRouteAndDateHeader }.
		{ #shipmentRoute . #thing: . self shipmentRoute }.
		{ #shipmentDates . #thing: . self shipmentDates}.
	} full: { 
		{ #routeAndDateRemarks . #text: . 'Route and date remarks'}.
	}
! !

!GCServiceData class methodsFor: 'asvo-shipmentRouteAndDate' stamp: 'hk 5/2/2017 16:47'!
shipmentRouteAndDateHeader
	"self shipmentRouteAndDateHeader edit"

	^GbtSmartThing struct: 'GCShipmentRouteAndDateHeader' define: {
		{ #summary . 'DISTANCE #routeDistance TOLL ROADS #tollRoadDistance' }.
		{ #routeDistance . #thing: . GCCommons gcDistance }.
	} full: { 
		{ #tollRoadDistance . #thing: . GCCommons gcDistance}.
	}
! !

!GCServiceData class methodsFor: 'asvo-shipmentgoods' stamp: 'hk 5/2/2017 16:47'!
singleShipmentGoodsItemVolume
	"self shipmentGoodsItemVolume edit"

	^GbtSmartThing struct: 'GCSingleShipmentGoodsItemVolume' define: {
		{ #purpose . #volume}.
		{ #summary . ' #volume #volumeUnit' }.
		{ #volume . #no: . 0 }.
"		{ #volumeCalculated . #calc: . 'prod #dimensionVolume'}."
		{ #volumeUnit . #enum: . GCCommons enumGCVolumeUnits  }
	} full: {
		{ #length . #no:from:to:tag: . 0 . 0 . nil . #dimensionVolume}.
		{ #breadth . #no:from:to:tag: . 0 . 0 . nil . #dimensionVolume}.
		{ #hight . #no:from:to:tag: . 0 . 0 . nil . #dimensionVolume}.
		{ #dimensionUnit . #enum: . GCCommons enumGCDimensionUnits  }.
"		{ #volumeWeightUnit . #enum: . GCCommons enumGCVolumeWeightUnits  }.
		{ #volumeWeight . #no: . 0}."
	}








! !

!GCServiceData class methodsFor: 'asvo-shipmentgoods' stamp: 'hk 5/2/2017 16:47'!
singleShipmentGoodsItemWeight
	"self singleShipmentGoodsItemWeight edit"

	^GbtSmartThing struct: 'GCSingleShipmentGoodsItemWeight' define: {
		{ #purpose . #weight}.
		{ #summary . ' #grossWeight #weightUnit' }.
		{ #grossWeight . #no: . 0}.
		{ #weightUnit . #enum: . GCCommons enumGCWeightUnits  }.
	} full: {  
		{ #netWeight . #no: . 0}.
	}

	






! !

!GCServiceData class methodsFor: 'asvo-serviceData' stamp: 'hk 5/2/2017 16:47'!
tourNote
	"self tourNote edit"
	
	^GbtSmartThing struct: 'GCTourNote' define: {
	{ #purposes . #(local shared)}.
	{ #summary . '#textNote' }.
	{ #textNote . #text: . 'tour note'}.	
	{ #tourDetails . #text: . ''}	
 	} full: {  
	}










! !

!GCServiceData class methodsFor: 'asvo-shipment' stamp: 'hk 5/2/2017 16:47'!
transportLocation
	"self transportLocation edit"

	^GbtSmartThing struct: 'GCTransportLocation' define: {
		{ #summary . '#streetAndNo , #postalCode #city , #country'}.
		{ #streetAndNo . #val: . 'street and no '}.
		{ #city . #val: . 'city'}.
		{ #postalCode . #val: . ''}.
		{ #country . #enum: . GCCommons enumCountries}.
	} full: { 
		{ #locationContact . #thing: . self pickupDeliveryContact}.
		{ #locationSpecifics . #listOf: . { self loadingTime . self locationNote}}.
		}






! !

!GCServiceData class methodsFor: 'asvo-service data item transport' stamp: 'hk 5/2/2017 16:47'!
transportRole
	"self transportRole edit"

	^GbtSmartThing struct: 'GCTransportRole' define: { 
		{ #purposes . GCCommons enumTransportRoles}.
		{ #summary . ''}.
		{ #transportRoleContact . #thing: . GCContact contact }.
 	} full: {  
	}
 

! !

!GCServiceData class methodsFor: 'asvo-service data item transport' stamp: 'hk 5/2/2017 16:47'!
vehicleMeans
	"self vehicleMeans edit"

	^GbtSmartThing struct: 'GCVehicleMeans' define: { 
		{ #purposes . #(road) }.	
		{ #summary . '#vehicleType' }.
		{ #vehicleType . #enum: . GCCommons enumVehicleType }.
 	} full: {  
		{ #vehicleNote . #text: . 'note on vehicle'}.
		{ #vehicleAuxiliaryMeans . #enum: . GCCommons enumAuxiliaryMeans }.
		{ #vehicle . #thing: . GCVehicles vehicle}.
		{ #drivers . #thing: . GCDrivers drivers}.
	}
	




! !

GCBizStructures subclass: #GCTariffs
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_GC_Things'!

!GCTariffs commentStamp: 'CC 8/18/2015 15:42' prior: 0!
I define the structur of various tariffs.

Every tariff is associated with service parameters. 

These parameters are part of associated service data items (roadTransport type, projectService type). Their values are used to lookup the tariff table to determine prices and costs.!

!GCTariffs class methodsFor: 'asvo-xref' stamp: 'CC 7/30/2015 22:37'!
contact
	""
	
	^GCContact contact! !

!GCTariffs class methodsFor: 'asvo-enums' stamp: 'CC 8/10/2015 18:42'!
enumProjectParameters
	"service parameter units"

	^GCCommons enumProjectParameters
	! !

!GCTariffs class methodsFor: 'asvo-enums' stamp: 'CC 8/10/2015 18:44'!
enumServiceParameters
	"self enumServiceParameters"

	^GCCommons enumServiceParameters
! !

!GCTariffs class methodsFor: 'asvo-enums' stamp: 'CC 9/17/2015 12:17'!
enumTariffCategories
	"categorization of tariffs"

	^ #(transport project waitingTime auxiliaryTools insurance surcharge)! !

!GCTariffs class methodsFor: 'asvo-enums' stamp: 'CC 8/10/2015 18:44'!
enumTransportParameters
	"service parameter units"

	^GCCommons enumTransportParameters! !

!GCTariffs class methodsFor: 'asvo-tariff' stamp: 'hk 5/2/2017 16:47'!
parameterSpec
	"self parameterSpec edit"

	^GbtSmartThing struct: 'GCParameterSpec' define: { 
		{ #baseParameterName . #enum: . GCCommons enumBaseParameters }.
		{ #parameterUnit . #enum: . GCCommons enumBaseParameterUnits }.
		{ #unitDomain . #val: . '' }.
		{ #domainRange . #val: . '' }.
 	} full: {  
	}








! !

!GCTariffs class methodsFor: 'asvo-tariff' stamp: 'hk 5/2/2017 16:47'!
priceCalculation
	"self priceCalculation edit"

	^GbtSmartThing struct: 'GCPriceCalculation' define: { 
		{ #formula . #val: . ''}.
		{ #price . #no: . 0}.
 	} full: {  
	}








! !

!GCTariffs class methodsFor: 'asvo-tariff' stamp: 'hk 5/2/2017 16:47'!
priceDescription
	"self priceDescription edit"

	^GbtSmartThing struct: 'GCPriceDescription' define: { 
		{ #currency . #enum: . GCCommons gcCurrency }.
		{ #pricingUnits  . #listOf: . {self pricingUnit . self surchargeUnit} }.
		{ #priceCalculation . #thing: . self priceCalculation}.
 	} full: {  
	}








! !

!GCTariffs class methodsFor: 'as yet unclassified' stamp: 'hk 5/2/2017 16:47'!
pricingUnit
	"self pricingUnit edit"

	^GbtSmartThing struct: 'GCPricingUnit' define: { 
		{ #summary . 'qty: #unitQuantity unit: #unitName pricePerUnit: #pricePerUnit'}.
		{ #unitQuantity . #no: . 0 }.
		{ #unitName . #enum: . GCCommons enumBaseParameterUnits }.
		{ #pricePerUnit . #no: . 0 }.	
 	} full: {  
	}








! !

!GCTariffs class methodsFor: 'as yet unclassified' stamp: 'hk 5/2/2017 16:47'!
surchargeUnit
	"self surchargeUnit edit"

	^GbtSmartThing struct: 'GCSurchargeUnit' define: { 
		{ #summary . 'priceItemRef: #priceItemBizId %: #percentage surchargePrice: #surchargePricePerItem'}.
		{ #priceItemBizId . #val: . 'none' }.
		{ #percentage . #no: . 0 }.
		{ #surchargePricePerItem . #no: . 0 }.	
 	} full: {  
	}








! !

!GCTariffs class methodsFor: 'asvo-tariff' stamp: 'hk 5/2/2017 16:47'!
tariff
	"self tariff edit"

	^GbtSmartThing struct: 'GCTariff' define: { 
		{ #idNumberPolicy . #GCDefaultNoPolicy }.
		{ #tariffDescription . #text: . '' }.
		{ #tariffRemarks . #text: . '' }.
		{ #tariffSource . #enum: . #(agent customer supplier) }.
		{ #tariffProvider . #val: . '' }.
		{ #tariffOwnership . #val: . '' }.
		{ #tariffCurrency . #enum: . GCCommons gcCurrency }.
		{ #tariffValidity . #thing: . self tariffValidity }.
		{ #tariffCategories . #enum: . self enumTariffCategories }.		
		{ #tariffTable . #thing: . self tariffTable }.
 	} full: {  
	}








! !

!GCTariffs class methodsFor: 'asvo-tariff' stamp: 'CC 8/20/2015 09:12'!
tariffCurrency
	"self tariffCurrency edit"
	
	^GCCommons enumGCCurrency! !

!GCTariffs class methodsFor: 'asvo-tariff' stamp: 'hk 5/2/2017 16:47'!
tariffOwnership
	"self tariffOwnership edit"
	
	^GbtSmartThing struct: 'GCTariffOwnership' define: { 
		{ #tariffSource . #enum: . #(own externalCustomer externalSupplier) }.
		{ #tariffProviders . #listOf: . self contact}.
 	} full: {  
	}! !

!GCTariffs class methodsFor: 'asvo-tariff' stamp: 'hk 5/2/2017 16:47'!
tariffParameterSpec
	"self tariffParameterSpec edit"

	^GbtSmartThing struct: 'GCTariffParameterSpec' define: { 
		{ #parameterSpecs . #listOf: . self parameterSpec }.
 	} full: {  
	}








! !

!GCTariffs class methodsFor: 'asvo-tariff' stamp: 'hk 5/2/2017 16:47'!
tariffTable
	"self tariffTable edit"
	"A tariff table has rows which set up a space of separated parameter values.
	Each row contains associated price calculations"
	"It may be implemented as a hash table with n-tuples as hash keys.
	Access to a tariffTable thing has an interface aTariffTable keys: yielding a lookup value."
	
	^GbtSmartThing struct: 'GCTariffTable' define: { 
		{ #tariffTableDescription . #text: . '' }.
		{ #tariffTableRows . #listOf: . self tariffTableRow}.
 	} full: {  
	}








! !

!GCTariffs class methodsFor: 'asvo-tariff' stamp: 'hk 5/2/2017 16:47'!
tariffTableRow
	"self tariffTableRow edit"

	^GbtSmartThing struct: 'GCTariffTableRow' define: {
		{ #summary . 'parameters priceDescription' }.
		{ #tariffParameterSpecifications . #thing: . self tariffParameterSpec }.
		{ #priceDescription . #thing: . self priceDescription}.
 	} full: {  
	}








! !

!GCTariffs class methodsFor: 'asvo-company master data' stamp: 'hk 5/2/2017 16:47'!
tariffTemplate
	"self tariffTemplate edit"

	^GbtSmartThing struct: 'GCTariffTemplate' define: { 
		{ #tariffTemplateIdentity . #thing: . self tariffTemplateIdentity }.
		{ #tariff . #thing: . self tariff }.
 	} full: {  
	}
! !

!GCTariffs class methodsFor: 'asvo-company master data' stamp: 'hk 5/2/2017 16:47'!
tariffTemplateIdentity
	"self tariffTemplateIdentitiy edit"

	^GbtSmartThing struct: 'GCTariffTemplateIdentity' define: { 
		{ #idNumberPolicy . #GCDefaultNoPolicy }.
		{ #templateName . #val: . 'template name'}.
		{ #templateGroup . #val: . 'template group'}.
 	} full: {  
	}
! !

!GCTariffs class methodsFor: 'asvo-company master data' stamp: 'hk 5/2/2017 16:47'!
tariffTemplates
	"self tariffTemplates edit"

	^GbtSmartThing struct: 'GCTariffTemplates' define: { 
		{ #tariffs . #listOf: . self tariffTemplate }.
 	} full: {  
	}
! !

!GCTariffs class methodsFor: 'asvo-tariff' stamp: 'CC 8/18/2015 14:41'!
tariffValidity
	""
	
	^GCCommons gcValidity! !

!GCTariffs class methodsFor: 'as yet unclassified' stamp: 'hk 5/2/2017 16:47'!
tariffs
	"self tariffs edit"

	^GbtSmartThing struct: 'GCTariffs' define: { 
		{ #tariffs . #listOf: . self tariffTemplate }.
 	} full: {  
	}
! !

!GCTariffs class methodsFor: 'asvo-xref' stamp: 'CC 7/30/2015 22:39'!
validity

	^GCCommons gcValidity! !

GCBizStructures subclass: #GCTaskStructures
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_GC_Things'!

!GCTaskStructures commentStamp: 'CC 8/30/2015 13:11' prior: 0!
Task Templates serve to catch standard task items.!

GCTaskStructures subclass: #GCProject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_GC_Things'!

!GCTaskStructures class methodsFor: 'asvo-taskOrder' stamp: 'hk 5/2/2017 16:47'!
taskOrder
	"self taskOrder edit"

	^GbtSmartThing struct: 'GCTaskOrder' define: { 
		{ #idNumberPolicy . #GCTaskOrderNoPolicy }.
		{ #summary . '#taskOrderType : #taskOrderActivationPattern' }.
		{ #taskOrderType . #enum: . GCCommons enumServiceCategories }.
		{ #taskOrderDispatch . #enum: . GCCommons enumTaskOrderDispatch }.
		{ #taskOrderStatus . #enum: . GCCommons enumTaskOrderStatus }.
		{ #bizProcessBizId . #val: . '#GCBizProcessBizId' }.
		{ #bizProcessActivityBizId . #val: . '#GCBizProcessActivityBizId' }.
		{ #taskBizId . #val: . '#GCTaskBizId' }.
		{ #taskOrderActivationPattern . #enum: . GCCommons enumActivationPatterns  }.
 	} full: {  
		{ #serviceData . #thing:tag: . GCServiceData  serviceData . #blackboard}.
		{ #taskOrderDueDate . #thing: . GCCommons gcDate }.
		{ #taskOrderCreationDate . #thing: . GCCommons gcDate }.
		{ #taskOrderActivationSchedule . #thing: . GCCommons gcCalendar }.							
	}


! !

!GCTaskStructures class methodsFor: 'asvo-company master data' stamp: 'hk 5/2/2017 16:47'!
taskTemplates
	"self taskTemplates edit"

	^GbtSmartThing struct: 'GCTaskTemplates' define: { 
		{ #summary . 'Under development' }.
		"{ #tourTemplates . #listOf: . self tourTemplate }.
		{ #projectTemplates . #listOf: . self projectTemplate }.
		{ #mobileDeliveryTemplates . #listOf: . self mobileDeliveryTemplate }."
 	} full: {  
	}
! !

!GCTaskStructures class methodsFor: 'asvo-company master data' stamp: 'hk 5/2/2017 16:47'!
tasks
	"self tasks edit"

	^GbtSmartThing struct: 'GCTasks' define: { 
		{ #summary . 'Under development' }.
		{ #tourTemplates . #val: . 'self tourTemplate' }.
"		{ #projectTemplates . #listOf: . self projectTemplate }.
		{ #mobileDeliveryTemplates . #listOf: . self mobileDeliveryTemplate }."
 	} full: {  
	}
! !

GCTaskStructures subclass: #GCTour
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_GC_Things'!

GCActiveServiceMasterData subclass: #GCLogisticsBizData
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_GC_Things'!

!GCLogisticsBizData commentStamp: 'CC 8/30/2015 12:38' prior: 0!
This data is user driven, depending on the use of the application.!

GCLogisticsBizData subclass: #GCDrivers
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_GC_Things'!

!GCDrivers class methodsFor: 'asvo-drivers' stamp: 'hk 5/2/2017 16:47'!
drivers
	"self drivers edit"

	^GbtSmartThing struct: 'GCDrivers' define: { 
		{ #purposes . #(driver) }.	
		{ #summary . '#driver' }.
		{ #driver . #thing: . GCContact contact }.
 	} full: {  
	}
	! !

GCLogisticsBizData subclass: #GCLoadingDeviceAccounts
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_GC_Things'!

!GCLogisticsBizData class methodsFor: 'asvo-company master data' stamp: 'hk 5/2/2017 16:47'!
logisticsBizData
	"self logisticsBizData edit"
	"These master data are not system master data but application master data."
	
	^GbtSmartThing struct: 'GCLogisticsBizData' define: {
		{ #summary .  'under development' }.
		"{ #drivers .  #thing: . GCDrivers driverData }.
		{ #vehicles .  #thing: . GCVehicles vehicleData}.
		{ #loadingDeviceAccounts .  #thing: . GCLoadingDeviceAccounts loadingDeviceAccounts}.	
		{ #standardRoutes .  #thing: . GCStandardRoutes standardRoutes}.		"
 	} full: {  
	}! !

GCLogisticsBizData subclass: #GCStandardRoutes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_GC_Things'!

GCLogisticsBizData subclass: #GCVehicles
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_GC_Things'!

!GCVehicles class methodsFor: 'as yet unclassified' stamp: 'hk 5/2/2017 16:47'!
vehicle
	"self vehicle edit"

	^GbtSmartThing struct: 'GCVehicle' define: { 
		{ #purposes . #(vehicle) }.	
		{ #summary . '#vehicle' }.
		{ #vehicle . #text: . 'vehicle data' }.
 	} full: {  
	}
	! !

GCActiveServiceMasterData subclass: #GCManagementInformation
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_GC_Things'!

!GCManagementInformation commentStamp: 'CC 8/30/2015 12:40' prior: 0!
This is used to define parameters for collecting management relevant information continously.

Besides, ist allows to evaluate biz process data like reqest, offer, order or revenues.
!

!GCManagementInformation class methodsFor: 'asvo-company master data' stamp: 'hk 5/2/2017 16:47'!
managementInformation
	"self managementInformation edit"
	"Core parameters for an ActiveService"
	
	^GbtSmartThing struct: 'GCManagementInformation' define: {
		{ #summary .  'under development' }.	
		"{ #managementStatistics .  #thing: . self  managementStatistics }."	
 	} full: {  
	}! !

GCActiveServiceMasterData subclass: #GCMasterData
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_GC_Things'!

!GCMasterData commentStamp: 'CC 8/29/2015 19:05' prior: 0!
Master Data structures parameters which are relevant for all processes, e.g. a local currency.

!

GCMasterData subclass: #GCBizMasterData
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_GC_Things'!

!GCBizMasterData commentStamp: 'CC 7/31/2015 11:47' prior: 0!
I implement beneral business data, mainly commercial usage

BizDomainData - master data that applies to gerneral business terms without branch specifics, i.e. commercial issues like currency exchange rates, tax master data

DocumentDefaults - standard text blocks for docs


ZUGFeRD -  data from standardized invoice regulations; internationally, this is covered by ISO norms!

!GCBizMasterData class methodsFor: 'asvo-bizDomainData' stamp: 'hk 5/2/2017 16:47'!
bizDomainData
	"self bizDomainData edit"
	"comment stating purpose of message"


	^GbtSmartThing struct: 'GCBizDomainData' define: { 
		{ #localCurrency . #val: . #EUR }.
		{ #currencies . #enum: . GCCommons enumGCCurrency }.
		"{ #taxData . #val: . #EUR }.
		{ #vatIdNo . #val: . #EUR }.
		{ #appSettings . #val: . #EUR }.
		{ #bizValueRanges . #val: . #EUR }.
		{ #serviceStandards . #val: . #EUR }.
		{ #accountingParameters . #val: . #EUR }.
		{ #printing . #val: . #EUR }.
		{ #bizProcessSettings . #val: . #EUR }.
		{ #bizDefaults . #val: . #EUR }."
 	} full: {  
	}! !

!GCBizMasterData class methodsFor: 'asvo-company master data' stamp: 'hk 5/2/2017 16:47'!
bizMasterData
	"self bizMasterData edit"

	
	^GbtSmartThing struct: 'GCBizMasterData' define: {
		{ #summary .  'under development' }.
		{ #bizDomainData .  #thing: . self bizDomainData }.
 	} full: {  
	}! !

GCMasterData subclass: #GCLogisticsMasterData
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_GC_Things'!

!GCLogisticsMasterData class methodsFor: 'asvo-company master data' stamp: 'hk 5/2/2017 16:47'!
logisticsMasterData
	"self logisticsMasterData edit"

	
	^GbtSmartThing struct: 'GCLogisticsMasterData' define: {
		"{ #systemMasterData .  #thing: . GCSystemMasterData systemMasterData }.
		{ #bizMasterData .  #thing: . GCBizMasterData  bizMasterData}.
		{ #logisticsMasterData .  #thing: . GCLogisticsMasterData  logisticsMasterData}.		"
 	} full: {  
	}! !

!GCMasterData class methodsFor: 'asvo-company master data' stamp: 'hk 5/2/2017 16:47'!
masterData
	"self masterData edit"
	"Core parameters for an ActiveService"
	
	^GbtSmartThing struct: 'GCMasterData' define: {
		{ #systemMasterData .  #thing: . GCSystemMasterData systemMasterData }.
		{ #bizMasterData .  #thing: . GCBizMasterData  bizMasterData}.
		{ #logisticsMasterData .  #thing: . GCLogisticsMasterData  logisticsMasterData}.		
 	} full: {  
	}! !

GCMasterData subclass: #GCSystemMasterData
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_GC_Things'!

!GCSystemMasterData commentStamp: 'hk 8/4/2015 14:20' prior: 0!
CC 8/4/2015 12:49
I represent the structures for the active service agent itself, and parameters defining the technology and the application environment.!

!GCSystemMasterData class methodsFor: 'asvi-active service agent' stamp: 'CC 1/30/2016 13:37'!
activeServiceAgent
    "self activeServiceAgent edit"
    "an active service agent is a contact with additional features of staff persons"


	^GCContact contact
"    | agentStaffPerson agent |    
	 agentStaffPerson := GCContact staffPerson copyWithName:'GCAgentStaffPerson'.
    agentStaffPerson purposes: #(agentStaffMember).
    agentStaffPerson personInfo addTemplate: self agentStaffPersonData.
    agent := GCContact contact copyWithName: 'GCActiveServiceAgent'.
    agent purposes: #agent.
    agent staff templates: agentStaffPerson.
    ^agent"
! !

!GCSystemMasterData class methodsFor: 'asvi-active service agent' stamp: 'hk 5/2/2017 16:47'!
agentStaffPersonData
	"self agentStaffPersonData edit"
	"Any agent staff has a user account"

	^GbtSmartThing struct: 'GCAgentStaffPersonData' define: {
	{#purposes	. #(agentStaffUserData)}.
	{#summary	. 'agent staff user data'}.
	{ #activeServiceUserAccount . #text: . 'GCActiveServiceUserAccount'}
	}
	full: {  
	{#employmentStatus	. #enum: . #(internal external)}.
	{#departments . #val: . 'GCDepartments'}.
	{#personalisation . #val: . 	'GCContextUserSetting'}.
	}! !

!GCSystemMasterData class methodsFor: 'asvo-application environment' stamp: 'hk 5/2/2017 16:47'!
applicationEnvironment
	"self activeServiceAgent edit"

	^GbtSmartThing struct: 'GCApplicationEnvironment' define: {
		{ #summary . 'to be completed'}.
		{ #languages . #enum: . #(English German Spanish)}.
 	} full: {  
	}! !

!GCSystemMasterData class methodsFor: 'asvo-company master data' stamp: 'hk 5/2/2017 16:47'!
systemMasterData
	"self systemMasterData  edit"

	^GbtSmartThing struct: 'GCSystemMasterData' define: {
		{ #summary . 'to be completed'}.
		{ #technicalEnvironment . #thing: . self technicalEnvironment}.
		{ #applicationEnvironment . #thing: . self applicationEnvironment}.
		{ #activeServiceAgent . #thing: . self activeServiceAgent}.
 	} full: {  
	}! !

!GCSystemMasterData class methodsFor: 'asvo-technical environment' stamp: 'hk 5/2/2017 16:47'!
technicalEnvironment
	"self technicalEnvironment edit"

	^GbtSmartThing struct: 'GCTechnicalEnvironment' define: {
		{ #summary . 'to be completed'}.
		{ #hostingSite . #enum: . #(GER  IRE USA)}.
 	} full: {  
	}! !

GCActiveServiceMasterData subclass: #GCUserSettings
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_GC_Things'!

!GCUserSettings commentStamp: 'CC 8/29/2015 19:12' prior: 0!
User Settings include personal settings for roles!

!GCUserSettings class methodsFor: 'asvo-company master data' stamp: 'hk 5/2/2017 16:47'!
userSettings
	"self userSettings edit"
	"User settings surviving an user session."
	
	^GbtSmartThing struct: 'GCUserSettings' define: {
		{ #summary .  'under development' }.	
		"{ #rightsAndRolesSettings .  #thing: . self rightsAndRolesSettings }.	
		{ #userBizNetSettings .  #thing: . self userBizNetSettings }.				
		{ #userContextSettings .  #thing: . self userContextSettings }."				
 	 	} full: {  
	}! !

Object subclass: #GCCommons
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_GC_Things'!

!GCCommons commentStamp: 'cc 7/29/2015 20:04' prior: 0!
I collect those asvo elements that are very common and used everywhere in the authoring code.!

!GCCommons class methodsFor: 'asvo-helpers' stamp: 'CC 11/11/2015 15:07'!
currentDate
	""
	
	^Date today printString
! !

!GCCommons class methodsFor: 'asvo-helpers' stamp: 'hk 5/2/2017 16:47'!
dateTimeSlot
	"self dateTimeSlot edit"

	^GbtSmartThing struct: 'GCDateTimeSlot' define: {
		{ #purposes . #(dateTimeSlot)}.
		{ #summary . '#hour slot #earliest to #latest ' }.
		{ #date . #date: . Date today }.
		{ #hour . #val: . 'an hour' }}
	full: { 
		{ #earliest . #val: . '' }.
		{ #latest . #val: . '' }.
	}! !

!GCCommons class methodsFor: 'asvo-enums' stamp: 'CC 8/31/2015 13:15'!
enumActivationPatterns
	"how is a task order to be activated regularly"

	^#(oneTime weekly monthly periodically)! !

!GCCommons class methodsFor: 'asvo-enums' stamp: 'CC 9/18/2015 12:54'!
enumActivityStatus
	"status is updated from tasks"

	^#(none request planned offer allocated  order started complete completeWithChange)! !

!GCCommons class methodsFor: 'asvo-enums' stamp: 'CC 9/18/2015 10:02'!
enumAspectIssuer
	"role of editor of aspect"

	^#(agent customer supplier)! !

!GCCommons class methodsFor: 'asvo-enums' stamp: 'CC 9/18/2015 09:40'!
enumAspectStatus
	"edit status of an aspect"

	^#(none edit complete)! !

!GCCommons class methodsFor: 'asvo-enums' stamp: 'CC 9/18/2015 09:54'!
enumAspectTypes
	"aspects of an ActiveService"

	^#(request offer order orderAcknowledgement activities invoices taskOrder supplierBizProcess supplierBizSubprocess)! !

!GCCommons class methodsFor: 'logistics' stamp: 'CC 1/26/2016 09:40'!
enumAuxiliaryMeans

	^#(truckCrane hoseA hoseB)! !

!GCCommons class methodsFor: 'asvo-enums' stamp: 'CC 9/17/2015 11:59'!
enumBaseParameterUnits
	"will include user defined units (e.g. enums of vehicles)"

		^#(km kg t h min m3 piece skillA skillB vehicleClass1 vehicleClass2)! !

!GCCommons class methodsFor: 'asvo-enums' stamp: 'CC 9/17/2015 09:08'!
enumBaseParameters
	"service parameters "

	^#(distance grossWeight volume volumeWeight  loadingSpaceMeters effortHr effortMin vehicle skillLevel)! !

!GCCommons class methodsFor: 'asvo-enums' stamp: 'CC 11/12/2015 11:08'!
enumBizNetRoles
	"various types of notes"

	^#(customer supplier)! !

!GCCommons class methodsFor: 'asvo-enums' stamp: 'CC 9/19/2015 12:33'!
enumBizProcessStatus

	^#(request offer order orderAcknowldegment operations completed)! !

!GCCommons class methodsFor: 'asvo-enums' stamp: 'CC 9/19/2015 12:31'!
enumBizProcessType

	^#(transport project)! !

!GCCommons class methodsFor: 'asvo-enums' stamp: 'CC 11/13/2015 23:17'!
enumCountries
	""

	^#(Germany Austria Denmark France Poland Switzerland TheNetherlands UK)! !

!GCCommons class methodsFor: 'asvo-enums' stamp: 'CC 11/11/2015 17:10'!
enumDispatchMode
	"how is a service to be dispatched"

	^#(ltl ftl container parcel modal ltlOrFtl)! !

!GCCommons class methodsFor: 'asvo-units' stamp: 'CC 11/11/2015 17:59'!
enumDistanceUnits
	"will include user defined units (e.g. enums of vehicles)"

		^#(km miles)! !

!GCCommons class methodsFor: 'asvo-enums' stamp: 'CC 8/20/2015 09:13'!
enumGCCurrency

	^#(EUR USD GBP)! !

!GCCommons class methodsFor: 'asvo-units' stamp: 'CC 11/27/2015 16:25'!
enumGCDimensionUnits

	^#(m cm dm)! !

!GCCommons class methodsFor: 'asvo-units' stamp: 'CC 8/20/2015 10:03'!
enumGCDimensionVolumeUnit

	^#(m cm dm)! !

!GCCommons class methodsFor: 'asvo-units' stamp: 'CC 11/11/2015 23:33'!
enumGCDimensionVolumeUnits

	^#(m cm dm)! !

!GCCommons class methodsFor: 'asvo-units' stamp: 'CC 8/20/2015 09:13'!
enumGCMeasureUnit

	^#(kg km t h d min m3 piece)! !

!GCCommons class methodsFor: 'asvo-enums' stamp: 'CC 11/11/2015 23:23'!
enumGCMeasureUnits

	^#(kg km t h d min m3 piece)! !

!GCCommons class methodsFor: 'asvo-units' stamp: 'CC 8/20/2015 09:14'!
enumGCProjectMeasureUnit

	^#(Ph Pd min piece)! !

!GCCommons class methodsFor: 'asvo-units' stamp: 'CC 11/11/2015 23:22'!
enumGCProjectMeasureUnits

	^#(Ph Pd min piece)! !

!GCCommons class methodsFor: 'asvo-units' stamp: 'CC 11/11/2015 23:28'!
enumGCVolumeUnits

	^#(cbm)! !

!GCCommons class methodsFor: 'asvo-units' stamp: 'CC 11/11/2015 23:29'!
enumGCVolumeWeightUnits

	^#(kg mt pds)! !

!GCCommons class methodsFor: 'asvo-units' stamp: 'CC 11/11/2015 23:27'!
enumGCWeightUnit

	^#(kg mt pds)! !

!GCCommons class methodsFor: 'asvo-units' stamp: 'CC 11/11/2015 23:27'!
enumGCWeightUnits

	^#(kg mt pds)! !

!GCCommons class methodsFor: 'logistics' stamp: 'CC 1/22/2016 12:28'!
enumIncoTerms

	^#(EXW FOB DDP)! !

!GCCommons class methodsFor: 'logistics' stamp: 'CC 1/26/2016 09:09'!
enumLoadingDeviceExchangeMode

	^#(modeA modeB none)! !

!GCCommons class methodsFor: 'logistics' stamp: 'CC 1/26/2016 09:16'!
enumLoadingDeviceQuality
	"comment stating purpose of message"

	^#(good medium damaged)! !

!GCCommons class methodsFor: 'logistics' stamp: 'CC 1/26/2016 09:11'!
enumLoadingDevices
	"comment stating purpose of message"

	^#(palette crate container)! !

!GCCommons class methodsFor: 'asvo-enums' stamp: 'CC 9/16/2015 20:49'!
enumNoteType
	"various types of notes"

	^#(note bizNote tourNote documentNote deliveryNote)! !

!GCCommons class methodsFor: 'asvo-enums' stamp: 'CC 11/11/2015 17:49'!
enumParameterGroups

	^#(resourceCatagory transport project)! !

!GCCommons class methodsFor: 'asvo-enums' stamp: 'CC 2/15/2016 12:56'!
enumPriceUnits
	"comment stating purpose of message"

	^#(piece shipment)! !

!GCCommons class methodsFor: 'asvo-enums' stamp: 'CC 11/11/2015 15:01'!
enumPriority

	^#(now high standard low)! !

!GCCommons class methodsFor: 'asvo-enums' stamp: 'CC 8/10/2015 18:54'!
enumProjectParameters
	"service parameter units"

	^#('serviceLevel/A'  'serviceLevel/B'  'serviceLevel/C' 'qty/min' 'qty/hrs' 'qty/piece')! !

!GCCommons class methodsFor: 'asvo-enums' stamp: 'CC 11/11/2015 17:13'!
enumScopeOfService
	"is a service item a transport or a shipment"

	^#(supplierShipment supplierTransport internalTransport internalShipment)! !

!GCCommons class methodsFor: 'asvo-enums' stamp: 'CC 8/3/2015 18:44'!
enumServiceCategories
	"comment stating purpose of message"

	^#(roadTransport modalTransport projectService generalService)! !

!GCCommons class methodsFor: 'asvo-enums' stamp: 'CC 8/10/2015 18:43'!
enumServiceParameters
	"self enumServiceParameters"

	|x|
	x := self enumTransportParameters asOrderedCollection.
	x addAll: (self enumProjectParameters).
	^x asArray
	! !

!GCCommons class methodsFor: 'logistics' stamp: 'CC 1/26/2016 09:52'!
enumShipmentDocuments

	^#(crm packingList shipmentLabels pickup delivery)! !

!GCCommons class methodsFor: 'asvo-enums' stamp: 'CC 1/22/2016 11:43'!
enumShipmentFrequency
	"self enumShipmentFrequency"

	^#(monthly weekly daily)
	! !

!GCCommons class methodsFor: 'asvo-enums' stamp: 'CC 11/12/2015 11:53'!
enumSimpleGroup
	""

	^#(simple group)! !

!GCCommons class methodsFor: 'asvo-enums' stamp: 'CC 8/31/2015 13:02'!
enumTaskOrderDispatch
	"how is a task order dispatched"

	^#(internal external any)! !

!GCCommons class methodsFor: 'asvo-enums' stamp: 'CC 8/31/2015 13:09'!
enumTaskOrderStatus
	"how is a task order dispatched"

	^ #(request planned/offer allocated/ordered started complete complete changed)! !

!GCCommons class methodsFor: 'asvo-enums' stamp: 'CC 11/12/2015 11:56'!
enumTaxCode
	"tax codes"

	^#('19%tax1' '7%tax2' '0%tax3')! !

!GCCommons class methodsFor: 'logistics' stamp: 'CC 1/22/2016 12:30'!
enumTermsAndConditions

	^#('f.o.t.')! !

!GCCommons class methodsFor: 'asvo-enums' stamp: 'CC 9/17/2015 09:23'!
enumTransportBaseParameters
	"service parameter units"

	^#(distance  grossWeight  volumeWeight volume loadingSpaceMeter)! !

!GCCommons class methodsFor: 'asvo-enums' stamp: 'CC 8/31/2015 13:03'!
enumTransportCategory
	"comment stating purpose of message"

	^#(roadTransport modalTransport)! !

!GCCommons class methodsFor: 'asvo-enums' stamp: 'CC 8/10/2015 18:43'!
enumTransportParameters
	"service parameter units"

	^#('distance/km'  'grossWeight/kg'  'volumeWeight/kg' 'volume/m3' 'loadingSpaceMeters/m')! !

!GCCommons class methodsFor: 'logistics' stamp: 'CC 1/26/2016 09:56'!
enumTransportRoles
	"comment stating purpose of message"

	^#(consignorSender consigneeReceiver buyer seller freightCarrier freightForwarder notify )! !

!GCCommons class methodsFor: 'logistics' stamp: 'CC 1/26/2016 09:47'!
enumVehicleType

	^#('12t' '40tTrailer' '1.8t' '7.5t' others)! !

!GCCommons class methodsFor: 'asvo-helpers' stamp: 'hk 5/2/2017 16:47'!
gcCalendar
	"self gcCalendar edit"
	
	^GbtSmartThing struct: 'GCCalendar' define: { 
	{ #summary . '#allocatedDates'}.
	{ #calendarName . #val: . 'a calendar name'}.
	{ #allocatedDates . #listOf: . self gcDate }
 	} full: {  
	}
! !

!GCCommons class methodsFor: 'asvo-helpers' stamp: 'CC 9/17/2015 12:27'!
gcCurrency
	""
	
	^self enumGCCurrency
! !

!GCCommons class methodsFor: 'asvo-helpers' stamp: 'hk 5/2/2017 16:47'!
gcDate
	"self gcDate edit"
	
	^GbtSmartThing struct: 'gcDate' define: { 
	{ #summary . '#gcDate'}.
	{ #gcDate . #date: . Date today}.
 	} full: {  
	}
! !

!GCCommons class methodsFor: 'asvo-helpers' stamp: 'hk 5/2/2017 16:47'!
gcDimensions
	"self gcDimensions edit"
	
	^GbtSmartThing struct: 'GCDimensions' define: { 
		{ #purpose . #dimensions}.
		{ #summary . 'length #length hight #hight breadth #breadth'}.
		{ #length . #no:from:to:tag: . 0 . 0 . nil . #dimensionVolume}.
		{ #hight . #no:from:to:tag: . 0 . 0 . nil . #dimensionVolume}.
		{ #breadth . #no:from:to:tag: . 0 . 0 . nil . #dimensionVolume}.
		{ #volume . #calc: . 'prod #dimensionVolume'}.
		{ #dimensionUnit . #enum: . GCCommons enumGCDimensionVolumeUnits  }.
 	} full: {  
	}
! !

!GCCommons class methodsFor: 'asvo-helpers' stamp: 'hk 5/2/2017 16:47'!
gcDistance
	"self gcDistance edit"

	^GbtSmartThing struct: 'GCDistance' define: {
		{ #purpose . #distance }.
		{ #summary . '#distance #distanceUnit' }.
		{ #distance . #no: . 0 }.
		{ #distanceUnit . #enum: . GCCommons enumDistanceUnits}.
 	} full: {  
	}
! !

!GCCommons class methodsFor: 'asvo-helpers' stamp: 'CC 8/13/2015 19:54'!
gcEMailNote

	^Text fromString: ''! !

!GCCommons class methodsFor: 'asvo-helpers' stamp: 'hk 5/2/2017 16:47'!
gcMonetaryValue
	"self gcMonetaryValue edit"

	^GbtSmartThing struct: 'GCMonetaryValue' define: {
		{ #purposes . #(monetaryValue) }.
		{ #summary . '#currencyValue #currencyUnit' }.
		{ #currencyValue . #no: . 0 }.
		{ #currencyUnit . #enum: . GCCommons enumGCCurrency}.
 	} full: {  
	}
! !

!GCCommons class methodsFor: 'asvo-helpers' stamp: 'cc 7/29/2015 18:33'!
gcNote

	^Text fromString: ''! !

!GCCommons class methodsFor: 'asvo-helpers' stamp: 'hk 5/2/2017 16:47'!
gcScheduleCalendar
	"self gcScheduleCalendar edit"
	
	^GbtSmartThing struct: 'GCScheduleCalendar' define: { 
	{ #summary . '#allocatedDates'}.
	{ #calendarName . #val: . 'a calendar name'}.
	{ #allocatedDates . #listOf: . self gcDate }
 	} full: {  
	}! !

!GCCommons class methodsFor: 'asvo-helpers' stamp: 'hk 5/2/2017 16:47'!
gcText
	"self gcText edit"
	
	^GbtSmartThing struct: 'GCTextNote' define: { 
		{ #purpose . #text}.
		{ #summary . '#text' }.
		{ #text . #text: . 'a text' }.
	 	} full: {  
	}! !

!GCCommons class methodsFor: 'asvo-helpers' stamp: 'hk 5/2/2017 16:47'!
gcTime
	"self gcTime edit"
	
	^GbtSmartThing struct: 'GCTime' define: { 
	{ #summary . '#time h'}.
	{ #time . #no: . 0}.
 	} full: {  
	}
! !

!GCCommons class methodsFor: 'asvo-helpers' stamp: 'hk 5/2/2017 16:47'!
gcValidity
	"self gcValidity edit"
	
	^GbtSmartThing struct: 'GCValidity' define: { 
		{ #startValidity . #val: . Date today printString}.
		{ #endValidity . #val: . Date today printString }.
 	} full: {  
	}
! !

!GCCommons class methodsFor: 'asvo-helpers' stamp: 'CC 1/25/2016 09:41'!
gcVolumeWeightFactor
	""
	
	^3.5
! !

!GCCommons class methodsFor: 'asvo-helpers' stamp: 'hk 5/2/2017 16:47'!
simpleTextNote
	"self simpleTextNoteX edit"

	^GbtSmartThing struct: 'GCSimpleTextNote'define: {
	{ #summary . '#textNote' }.
	{ #textNote . #text:for: . 'simple text note' . #(local shared)}.
 	} full: {  
	}! !

!GCCommons class methodsFor: 'asvo-helpers' stamp: 'hk 5/2/2017 16:47'!
textNote
	"self textNote edit"
	
	^GbtSmartThing struct: 'GCTextNote' define: { 
		{ #purpose . #note}.
		{ #summary . '#textNote' }.
		{ #textNote . #text: . 'a text' }.
	 	} full: {  
	}! !

!GCCommons class methodsFor: 'asvo-helpers' stamp: 'CC 9/16/2015 15:52'!
timeStamp
	"self timeStamp"
	
	^Date today mmddyyyy, ' ',
		((String streamContents: [:s | Time now print24: true on: s]) copyFrom: 1 to: 5)! !

Object subclass: #GCMain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_GC_Things'!

!GCMain commentStamp: 'CC 8/6/2015 23:53' prior: 0!
I represent the things accessible through the main view of an ActiveService.!

GCMain subclass: #GCBizProcess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_GC_Things'!

GCBizProcess class
	instanceVariableNames: 'gcBizProcessRequest'!

!GCBizProcess commentStamp: 'CC 7/30/2015 22:50' prior: 0!
I represent a business process with its various aspects.!

GCBizProcess class
	instanceVariableNames: 'gcBizProcessRequest'!

!GCBizProcess class methodsFor: 'asvo-bizActivities' stamp: 'hk 5/2/2017 16:47'!
activitiesDetails
	"self activitiesDetails editD"
	
	^GbtSmartThing struct: 'GCActivitiesDetails ' define: { 
		{ #costCurrency . #enum: . GCCommons gcCurrency }.
		{ #currencyConversionRates . #listOf: . GCBizAspectItems currencyConversion}.
		{ #activitiesNote . #text: . 'item note'}.
 	} full: {  
	}
	
! !

!GCBizProcess class methodsFor: 'asvo-bizProcess' stamp: 'hk 5/2/2017 16:47'!
aspectCustomerBizId
	^ GbtSmartThing
		struct: 'GCAspectCustomerBizId'
		define:
			{{#purpose . #customerBizId}.
			{#summary . '#supplierBizId - #processBizId - #subProcessBizId  - #aspectBizId - #aspectVersionBizId'}.
			{#customerBizId . #val: . ''}.
			{#supplierProcessBizId . #val: . ''}.
			{#supplierSubProcessBizId . #val: . ''}.
			{#aspectBizId . #val: . 'an aspect biz id'}.
			{#aspectVersionBizId . #val: . 'an aspect version biz id'}}
		full: {}! !

!GCBizProcess class methodsFor: 'asvo-bizProcess' stamp: 'hk 5/2/2017 16:47'!
aspectNote
	"self aspectNote edit"
	
	^GbtSmartThing struct: 'GCAspectNote' define: { 
		{ #purposes . #(bizProcess bizRequest bizOffer bizOrder bizActivities billableItems taskOrder)}.
		{ #summary . '#note' }.
		{ #note . #text: . 'a note' }.				
 	} full: {  
		{ #concern . #val: . 'a concern' }.
		{ #to . #val: . 'to: ' }.	
		{ #from . #val: . 'from: ' }.
		{ #aspect . #enum: . #(request offer order message) }.
		{ #issued . #thing: . GCCommons gcDate }.
		{ #attachments . #val: . 'docs and other .pdf-files' }.
	}
	
	



! !

!GCBizProcess class methodsFor: 'asvo-bizProcess' stamp: 'hk 5/2/2017 16:47'!
aspectProcessBizId
	"self aspectProcessBizId edit"
	
	^GbtSmartThing struct: 'GCAspectProcessBizId' define: { 
		{ #customerAspectBizId . #thing: . self aspectCustomerBizId }.		
		{ #supplierAspectBizId . #thing: . self aspectSupplierBizId }.				
 	} full: {  
	}! !

!GCBizProcess class methodsFor: 'asvo-bizProcess' stamp: 'hk 5/2/2017 16:47'!
aspectStatus
	"self aspectStatusX edit"
	
	^GbtSmartThing struct: 'GCAspectStatus' define: { 
		{ #purposes . #(bizProcess bizRequest bizOffer bizOrder bizActivities billableItems taskOrder)}.
		{ #summary . '#purpose due: #dueDate' }.
		{ #editMode . #enum: . GCCommons enumAspectStatus }.
		{ #issueDate . #date: . GCCommons timeStamp }.
		{ #completionBizId . #calc: . 'ref #bizId _ C _ #versionNo' }.
		{ #versionNo . #val:. '1' }.
		{ #dueDate . #date: . GCCommons currentDate }.	
		{ #creationDate . #date: . GCCommons timeStamp }.
		{ #majorServiceType . #enum: . #(transport project) }.		
		{ #priority . #enum: . #(now high standard low) }.			
		{ #previousAspectBizId . #val: . 'previous aspect bizId' }.			
		{ #aspectIssuer . #enum: . #(customer supplier) }.	
 	} full: {  
		{ #aspectOwner . #thing: . self bizProcessOwner }.
		{ #aspectProcessBizId . #thing: . self aspectProcessBizId }.						
	}
	
	



! !

!GCBizProcess class methodsFor: 'asvo-bizProcess' stamp: 'hk 5/2/2017 16:47'!
aspectSupplierBizId
	^ GbtSmartThing
		struct: 'GCAspectSupplierBizId'
		define:
			{{#purpose . #supplierBizId}.
			{#summary . '#customerBizId - #processBizId - #aspectBizId - #aspectVersionBizId'}.
			{#supplierBizId . #val: . ''}.
			{#bizProcessBizId . #val: . ''}.
			{#aspectBizId . #val: . 'an aspect biz id'}.
			{#aspectVersionBizId . #val: . 'an aspect version biz id'}}
		full: {}! !

!GCBizProcess class methodsFor: 'asvo-bizActivities' stamp: 'hk 5/2/2017 16:47'!
bizActivities
	"self bizActivities edit"
	
	^GbtSmartThing struct: 'GCBizActivities' define: { 
		{ #purposes . #(bizActivities) }.
		{ #idNumberPolicy . #GCBizActivityNoPolicy }.
		{ #summary . 'biz activities' }.
		{ #bizActivitiesHeader . #thing: . self bizActivitiesHeader }.	
		{ #bizActivitiesStatus . #thing: . self aspectStatus purpose: #bizActivities }.
		{ #bizActivitiesServiceData . #thing: . GCServiceData serviceData }. 
		{ #bizActivitiesCustomer . #thing: . GCContact contact }. 
		{ #bizActivitiesSupplier . #thing: . GCSystemMasterData activeServiceAgent }.
		{ #bizActivitiesItems . #listOf: . GCBizAspectItems activity}.
		{ #bizActivitiesCostTotals . #listOf: . self bizActivitiesCostTotals }.
		{ #activitiesDetails . #thing: . self activitiesDetails }.	
	 } full: { 
		{ #bizActivitiesNotes . #listOf: . self aspectNote }.
	 }! !

!GCBizProcess class methodsFor: 'asvo-bizActivities' stamp: 'hk 5/2/2017 16:47'!
bizActivitiesCostTotals
	"self bizActivitiesCostTotals editD"
	
	^GbtSmartThing struct: 'GCBizActivitiesCostTotals ' define: { 
		{ #priceTotals . #calc: . 'sum #price' }.	
		{ #variablePriceTotals . #calc: . 'sum #variablePrice' }.
		{ #housePriceTotals . #calc: . 'sum #housePrice' }.
 	} full: {  
	}
	! !

!GCBizProcess class methodsFor: 'asvo-bizActivities' stamp: 'hk 5/2/2017 16:47'!
bizActivitiesHeader
	"self bizActivitiesHeader edit"
	
	^GbtSmartThing struct: 'GCBizActivitiesHeader' define: { 
		{ #summary . 'biz activities' }.
		{ #activityDueDates . #val: . 'GCCommons gcDate' }.	
	 } full: { 

	 }! !

!GCBizProcess class methodsFor: 'asvo-bizProcess' stamp: 'CC 12/29/2015 15:14'!
bizCustomer
	"self bizCustomer editVO"
	
	^GCContact contact ! !

!GCBizProcess class methodsFor: 'asvo-bizRequestOfferOrder' stamp: 'hk 5/2/2017 16:47'!
bizMargin
	"self bizMarginX edit"

	^GbtSmartThing struct: 'GCBizMargin' define: { 
		{ #purpose . #bizMargin}.
		{ #summary . 'margin: #marginValue' }.
		{ #marginValue . #val: . '' }.					
		{ #associatedSupplierContractItems . #text: . 'associated supplier items' }.	 
	} full: {  
		}! !

!GCBizProcess class methodsFor: 'asvo-biz net message data' stamp: 'CC 8/31/2015 10:50'!
bizNetInvoice
	"self bizNetInvoice edit"
		
	^self bizInvoice! !

!GCBizProcess class methodsFor: 'asvo-biz net message data' stamp: 'CC 9/19/2015 13:37'!
bizNetOffer
	"self bizNetOffer edit"
		
	| x |
	x := self bizNetMessage.
	^x messageAspectData: self bizOffer aspectSharedBizData;
	yourself.! !

!GCBizProcess class methodsFor: 'asvo-biz net message data' stamp: 'CC 9/19/2015 13:37'!
bizNetOrder
	"self bizNetOrder edit"
		
	| x |
	x := self bizNetMessage.
	^x messageAspectData: self bizOrder aspectSharedBizData;
	yourself.! !

!GCBizProcess class methodsFor: 'asvo-biz net message data' stamp: 'CC 8/31/2015 10:51'!
bizNetOrderAcknowledgement
	"self bizNetOrderAcknowledgement edit"
		
	^self bizOrderAcknowledgement! !

!GCBizProcess class methodsFor: 'asvo-biz net message data' stamp: 'CC 9/19/2015 13:37'!
bizNetRequest
	"self bizNetRequest edit"
	
	| x |
	x := self bizNetMessage.
	^x messageAspectData: self bizRequest aspectSharedBizData;
	yourself.! !

!GCBizProcess class methodsFor: 'asvo-bizRequestOfferOrder' stamp: 'hk 5/2/2017 16:47'!
bizOffer
	"self bizOfferX editD"
	
	^GbtSmartThing struct: 'GCBizOffer' define: { 
		{ #purposes . #(bizOffer) }.
		{ #idNumberPolicy . #GCBizOfferPolicy }. 
		{ #summary . 'offer: #bizId itens: #bizOfferItems status: #bizRequestStatus' }.
		{ #bizOfferStatus . #thing: . self aspectStatus purpose: #bizOffer }.
		{ #bizOfferItems . #listOf: . GCBizAspectItems bizContractItem }.
	 } full: { 
		{ #bizOfferNotes . #listOf: . { self aspectNote } }.
		{ #bizOfferServiceData . #thing:tag: . GCServiceData serviceData . #blackboard}. 
		{ #bizOfferCustomer . #thing: . GCContact contact }. 
		{ #bizOfferSupplier . #thing: . GCSystemMasterData activeServiceAgent }.
	 }! !

!GCBizProcess class methodsFor: 'asvo-bizRequestOfferOrder' stamp: 'hk 5/2/2017 16:47'!
bizOrder
	"self bizOrder editD"
	
	^GbtSmartThing struct: 'GCBizOrder' define: { 
		{ #purposes . #(bizOrder) }.
		{ #idNumberPolicy . #GCBizOrderPolicy }. 
		{ #summary . 'Order: #bizId status: #bizRequestStatus' }.
		{ #bizOrderStatus . #thing: . self aspectStatus purpose: #bizOrder }.
		{ #bizOrderItems . #listOf: . GCBizAspectItems  bizContractItem }.
	 } full: { 
		{ #bizOrderNotes . #listOf: . { self aspectNote } }.
		{ #bizOrderServiceData . #thing:tag: . GCServiceData serviceData . #blackboard}. 
		{ #bizOrderCustomer . #thing: . GCContact contact }. 
		{ #bizOrderSupplier . #thing: . GCSystemMasterData activeServiceAgent }.
	 }! !

!GCBizProcess class methodsFor: 'asvo-bizRequestOfferOrder' stamp: 'hk 5/2/2017 16:47'!
bizOrderAcknowledgement
	"self bizOrderAcknowledgement edit"
	^GbtSmartThing struct: 'GCBizOrderAcknowledgement' define: { 
		{ #bizOfferOrder . #thing: . self bizOfferOrder }.				
 	} full: {  
	}! !

!GCBizProcess class methodsFor: 'asvo-bizProcess' stamp: 'hk 5/2/2017 16:47'!
bizProcess
	"self bizProcess editD"
	
	^GbtSmartThing struct: 'GCBizProcess' define: { 
		{ #purposes . #(bizProcess) }.
		{ #idNumberPolicy . #GCBizProcessNoPolicy }.
		{ #summary . 'bizId= #bizId'}.
		{ #bizProcessHeader . #thing: . self bizProcessHeader }.
		{ #bizProcessStatus . #thing: . self aspectStatus purpose: #bizProcess }.
	} full: { 
		{ #bizCustomer . #thing: . self bizCustomer }. 
		{ #bizProcessServiceData . #thing:tag: . GCServiceData serviceData . #blackboard}.
		{ #bizRequest . #thing: . self bizRequest }.
		{ #bizOffer . #thing: . self bizOffer }.		
		{ #bizOrder . #thing: . self bizOrder}.
"		{ #bizOrderAcknowledgment . #thing: . self bizOrderAcknowledgementX }."
		{ #bizActivities . #thing: . self bizActivities }.	
		"{ #bizTasks . #thing: . self bizTasks }."
"		{ #bizBillableItems . #thing: . self bizBillableItems }.	
		{ #bizInvoices . #thing: . self bizInvoices }.			"
"		{ #bizNetRequest . #thing: . self bizNetRequestX }.
		{ #bizNetOffer . #thing: . self bizNetOfferX }.	
		{ #bizNetOrder . #thing: . self bizNetOrderX }.			"
"		{ #bizNetOrderAcknowledgement . #thing: . self bizNetOrderAcknowledgment }.
		{ #bizNetInvoices . #thing: . self bizNetInvices }.			"
		{ #bizProcessNotes . #listOf: . self aspectNote }.										
	 }! !

!GCBizProcess class methodsFor: 'asvo-bizProcess' stamp: 'hk 5/2/2017 16:47'!
bizProcessHeader
	"self 	bizProcessHeader editD"

	^GbtSmartThing struct: 'GCBizProcessHeader' define: { 
		{ #purposes . #(bizProcessHeader) }.
		{ #summary . 'Customer #customerName Request #requestNo Offer #offerNo Order #orderNo' }.
		{ #customerName . #calc: . 'ref #bizCustomer:lastName' }.
		{ #customerReference . #calc: . 'ref #gloconnCustomerNo' }.
		{ #customerBizNetId . #calc: . 'ref #customerBizNetIdentity' }.
		{ #requestNo . #calc: . 'ref #bizRequest:completionBizId' }.
		{ #requestDate . #calc: . 'ref #bizRequest:issueDate' }.
		{ #offerNo . #calc: . 'ref #bizOffer:completionBizId' }.
		{ #offerDate . #calc: . 'ref #bizOffer:issueDate' }.
		{ #orderNo . #calc: . 'ref #gloconnCustomerNo' }.
		{ #orderDate . #calc: . 'ref #gloconnCustomerNo' }.
		{ #orderNo . #calc: . 'ref #gloconnCustomerNo' }.
		{ #dueDates . #listOf: . GCCommons gcDate}.
	 } full: { 
	 }




	
! !

!GCBizProcess class methodsFor: 'asvo-bizProcess' stamp: 'hk 5/2/2017 16:47'!
bizProcessOwner
	"self bizProcessOwner edit"
	
	^GbtSmartThing struct: 'GCBizProcessOwner' define: { 
		{ #purpose . #bizProcessOwner }.
		{ #summary . '#bizProcessOwner' }.
		{ #bizProcessOwner . #val: . 'a process owner staff name' }.
 	} ! !

!GCBizProcess class methodsFor: 'asvo-bizRequestOfferOrder' stamp: 'hk 5/2/2017 16:47'!
bizRequest
	"self bizRequest editD"

	^GbtSmartThing struct: 'GCBizRequest' define: { 
		{ #purposes . #(bizRequest) }.
		{ #idNumberPolicy . #GCDefaultPolicy }. "biz Id = BizProcessBizId"
		{ #summary . 'request: #bizId status: #bizRequestStatus' }.
		{ #bizRequestStatus . #thing: . self aspectStatus purpose: #bizRequest }.
	 } full: { 
		{ #bizRequestNotes . #listOf: . { self aspectNote } }.
		{ #bizRequestServiceData . #thing:tag: . GCServiceData serviceData . #blackboard}. 
		{ #bizRequestCustomer . #thing: . GCContact contact }. 
		{ #bizRequestSupplier . #thing: . GCContact contact }. 
	 }! !

!GCBizProcess class methodsFor: 'asvo-bizProcess' stamp: 'hk 3/14/2017 13:01'!
processContactCombinator
	"^ the view GCSupplierContact of contact"

	^GbtDeclarative struct: 'GCProcessContact' define: {
		{ #lastName }.	
		{ #street }.		
		{ #streetNo }.
		{ #cityName }.	
		{ #cityCode }.		
		{ #country }.
	}! !

!GCBizProcess class methodsFor: 'asvo-bizRequestOfferOrder' stamp: 'CC 2/28/2016 14:07'!
taskOrders
	"self taskOrder edit"

	^GCTaskOrder taskOrder









! !

GCMain subclass: #GCContact
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_GC_Things'!

!GCContact commentStamp: 'CC 7/27/2015 18:46' prior: 0!
A contact is a thing encompassing what a contact could need in various roles.

For specific contexts, views are tailored.

Access to various parts defined for a contact is modelled through methods starting with gc, i.e. gcAThingName, which yield an asvo copy of a defined thing structure.

!

!GCContact class methodsFor: 'asvo - address' stamp: 'hk 5/2/2017 16:47'!
address
	"self address edit"

	^GbtSmartThing struct: 'GCAddress' define: { 
		{ #purposes .  #(main)}.
		{ #summary .  '#street #streetNo #cityName'}.
		{ #street . #text: . ''}.		
		{ #streetNo . #val: . ''}.
		{ #cityName . #val: . ''}.	
		{ #cityCode . #val: . ''}.		
		{ #country . #enum: . GCCommons enumCountries}.
	} full: {
		{ #addressInfo . #listOf: . { self stateOrRegion . self locationInfo . self addressCode }}
	}







! !

!GCContact class methodsFor: 'asvo - address' stamp: 'hk 5/2/2017 16:47'!
addressCode
	"self addressCode edit"

	^GbtSmartThing struct: 'GCAddressCode' define: {
		{ #purposes .  #(addressCode)}.
		{ #summary .  'address code'}.
	} full: { 
		{ #addressCodeName . #val: . ''}.
		{ #addressCodeValue . #val: . ''}
	}! !

!GCContact class methodsFor: 'asvo - address' stamp: 'hk 5/2/2017 16:47'!
addressLocation
	"self addressLocation edit"

	^GbtSmartThing struct: 'GCAddressLocation' define: {  
		{ #summary . 'Street: #street No: #streetNo'} .	
		{ #street . #val: . 'street'} .
		{ #streetNo . #val: . 'street number'}.
	} full: {  
		{ #building . #val: . 'building'} .
		{ #locationName . #val: . 'location name'}.
	}! !

!GCContact class methodsFor: 'asvo-contact' stamp: 'hk 5/2/2017 16:47'!
company
	"self company edit"

	^GbtSmartThing struct: 'GCCompany' define: {
		{ #purposes . #(main)}.
		{ #summary . '#companyName'}.
		{ #companyName .  #val: . 'a company name'}.
	} full: {
		{ #companyType .  #val: . ''}.
		{ #companyRegistrationNo. #val: . ''}.
	}! !

!GCContact class methodsFor: 'asvo-contact' stamp: 'hk 5/2/2017 16:47'!
contact
	"self contact editD"

	^GbtSmartThing struct: 'GCContact' define: {
		{ #purposes .  #(externalContact agent)}.
		{ #summary .  '#firstName #lastName #company'}.
		{ #idNumberPolicy . #GCContactNoPolicy }.
		{ #firstName . #val: . ''}.
		{ #lastName . #val: . ''}.
		{ #company . #val: . ''}.					
		{ #eMail . #val: . '' }.					
		{ #phone .  #val: . '' } .
	} full: { 
		{ #note . #text: . ''}.
		{ #bizNetIdentity . #val: . ''}.							
		{ #address .  #listOf: . self address}.
		{ #staff .  #listOf: . self staffPerson}.
		{ #contactInfo .  #listOf: . { self phone . self eMail . self company . " self contactBizNetX . self bizIdentityNumbers . self tagsX . self bizInfoX . self contactLogisticsDataX . self contactAccountingDataX "}}
	}! !

!GCContact class methodsFor: 'asvo - address' stamp: 'hk 5/2/2017 16:47'!
eMail
	"self eMail edit"
	
	^GbtSmartThing struct: 'GCEMail' define: {
		{ #purposes .   #(biz private)}.
		{ #summary .  '#eMail'}.
		{ #eMail . #val: . 'an email'}.	
 	} full: {  
	}! !

!GCContact class methodsFor: 'asvo - address' stamp: 'hk 5/2/2017 16:47'!
locationInfo
	"self locationInfo edit"

	^GbtSmartThing struct: 'GCLocationInfo' define: {
		{ #purposes .  #('main location' 'invoice location' 'pickup location' 'delivery location')}.
		{ #summary .  'location info'}}
		full:{
		{ #locationUsage . #val: . ''}.
		{ #locationName . #val: . ''}
 	}! !

!GCContact class methodsFor: 'asvo-contact' stamp: 'hk 5/2/2017 16:47'!
personalData
	"self personalData edit"

	^GbtSmartThing struct: 'GCPersonalData' define: {
		{ #summary . '#personalDataItem'}.
	} full: {
		{ #personalDataItem . #text: . 'personal data' }
	}! !

!GCContact class methodsFor: 'asvo - address' stamp: 'hk 5/2/2017 16:47'!
phone
	"self phone edit"
	
	^GbtSmartThing struct: 'GCPhone' define: {
		{ #purposes .   #(mobilebiz mobileprivate biz private fax )}.
		{ #summary .  '#phoneNumber'}.
		{ #phoneNumber . #val: . 'a phone number'}.	
 	} full: {  
	}! !

!GCContact class methodsFor: 'asvo-contact' stamp: 'hk 5/2/2017 16:47'!
staffPerson
	"self staffPerson edit"

	^GbtSmartThing struct: 'GCStaffPerson' define: { 
		{ #purposes . #(staffMember)}.
		{ #summary .  '#firstName #lastName #eMail #phoneNumber'}.	
		{ #firstName . #val: . ''}.
		{ #lastName . #val: . ''}.				
		{ #eMail . #val: . ''}.					
		{ #phone . #val: . ''}.
	} full: {
		{ #personNote . #text: . ''}.
		{ #personInfo . #listOf: . { self phone . self eMail . GCSystemMasterData agentStaffPersonData ". self bizNetSettingsX . self personalDataX" }}.
	}! !

!GCContact class methodsFor: 'asvo - address' stamp: 'hk 5/2/2017 16:47'!
stateOrRegion
	"self stateOrRegion edit"

	^GbtSmartThing struct: 'GCStateOrRegion' define: {
		{ #purposes .  #(state region)}.
		{ #summary .  'state or region'}.
	} full: {
		{ #stateOrRegion . #val: . 'state or region'}.
	}! !

GCMain subclass: #GCInvoice
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_GC_Things'!

!GCMain class methodsFor: 'asvo-main application things' stamp: 'CC 8/6/2015 18:59'!
mainThings
	"self mainThings edit"
! !

GCMain subclass: #GCTaskOrder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_GC_Things'!

!GCTaskOrder class methodsFor: 'asvo-taskOrder' stamp: 'hk 5/2/2017 16:47'!
dispatchBase
	"self dispatchBase edit"

	^GbtSmartThing struct: 'GCDispatchBase' define: { 
		{ #summary . 'dispatcher: #mainDispatcher' }.
		{ #mainDispatcher . #thing: . self dispatcherStaffPerson  }.
		{ #taskOrderDispatchType . #enum: . #(internal external any)}.
 	} full: {  
		{ #deputeeDispatcher . #thing: . self dispatcherStaffPerson  }.
		{ #priority . #enum: . #(now high standard low)}.
		{ #dispatchDate . #thing: . GCCommons gcDate }.
		{ #activationSchedule . #thing: . GCCommons gcScheduleCalendar }.
		{ #activationPattern . #enum: . #(oneTime weekly monthly periodically) }.							
	}! !

!GCTaskOrder class methodsFor: 'asvo-taskOrder' stamp: 'hk 5/2/2017 16:47'!
dispatcherStaffPerson
	"self dispatcherStaffPerson edit"

	^GbtSmartThing struct: 'GCDispatcherStaffPerson' define: { 
		{ #summary . '#dispatcherStaffPerson' }.
		{ #dispatcherStaffPerson . #val: . 'a dispatcher staff person name' }.
 	} ! !

!GCTaskOrder class methodsFor: 'asvo-taskOrder' stamp: 'hk 5/2/2017 16:47'!
taskOrder
	"self taskOrder editD"

	^GbtSmartThing struct: 'GCTaskOrder' define: { 
		{ #idNumberPolicy . #GCTaskOrderNoPolicy }.
		{ #origin . #val: . '#GCBizId' }.
		{ #summary . 'no: #bizId service data: #taskOrderServiceData status: #taskOrderStatus' }.
		{ #taskOrderStatus . #thing: . GCBizProcess aspectStatus purpose: #taskOrder  }.
 	} full: {  
		{ #taskOrderServiceData . #thing: . GCServiceData  serviceData }.
		{ #dispatchBase . #thing: . self dispatchBase }.
		{ #taskOrderNotes . #listOf: . GCBizProcess aspectNote }.							
	}
! !

GCMain subclass: #GCTasks
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_GC_Things'!

GCTasks subclass: #GCMobileDelivery
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_GC_Things'!

GCTasks subclass: #GCProjectDelivery
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_GC_Things'!

GCTasks subclass: #GCProjectDispatch
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_GC_Things'!

GCTasks subclass: #GCSupplierBizProcess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_GC_Things'!

!GCSupplierBizProcess commentStamp: 'CC 8/31/2015 10:03' prior: 0!
There is one supplier biz process that is ordered to execute a task. 

For requesting a supplier pool, collecting offers, comparing, and selecting on for order, a set of supplier sub processes is managed.!

!GCSupplierBizProcess class methodsFor: 'asvo-aspects' stamp: 'CC 8/31/2015 10:42'!
bizInvoice
	"self bizInvoice edit"
		
	^GCBizProcess bizInvoice











! !

!GCSupplierBizProcess class methodsFor: 'asvo-biz net message data' stamp: 'CC 8/31/2015 10:48'!
bizNetInvoice
	"self bizNetInvoice edit"
		
	^GCBizProcess bizNetInvoice! !

!GCSupplierBizProcess class methodsFor: 'asvo-biz net message data' stamp: 'CC 8/31/2015 10:48'!
bizNetOffer
	"self bizNetOffer edit"
		
	^GCBizProcess bizNetOffer
! !

!GCSupplierBizProcess class methodsFor: 'asvo-biz net message data' stamp: 'CC 8/31/2015 10:48'!
bizNetOrder
	"self bizNetOrder edit"
		
	^GCBizProcess bizNetOrder
! !

!GCSupplierBizProcess class methodsFor: 'asvo-biz net message data' stamp: 'CC 8/31/2015 10:49'!
bizNetOrderAcknowledgement
	"self bizNetOrderAcknowledgement edit"
		
	^GCBizProcess bizNetOrderAcknowledgement
! !

!GCSupplierBizProcess class methodsFor: 'asvo-biz net message data' stamp: 'CC 8/31/2015 10:49'!
bizNetRequest
	"self bizNetRequest edit"
		
	^GCBizProcess bizNetRequest! !

!GCSupplierBizProcess class methodsFor: 'asvo-aspects' stamp: 'CC 8/31/2015 10:41'!
bizOrderAcknowledgement
	"self bizOrderAcknowledgement edit"
		
	^GCBizProcess bizOrderAcknowledgement











! !

!GCSupplierBizProcess class methodsFor: 'asvo-biz net message data' stamp: 'CC 9/18/2015 14:06'!
supplierBizNetOffer
	"self supplierBizNetOffer edit"
		
	^GCBizProcess bizNetOffer
! !

!GCSupplierBizProcess class methodsFor: 'asvo-biz net message data' stamp: 'CC 9/18/2015 14:07'!
supplierBizNetOrder
	"self supplierBizNetOrder edit"
		
	^GCBizProcess bizNetOrder
! !

!GCSupplierBizProcess class methodsFor: 'asvo-biz net message data' stamp: 'CC 9/18/2015 14:06'!
supplierBizNetRequest
	"self supplierBizNetRequest edit"
		
	^GCBizProcess bizNetRequest! !

!GCSupplierBizProcess class methodsFor: 'asvo-supplier biz process' stamp: 'hk 2/16/2016 14:24'!
supplierBizOffer
	"self supplierBizOfferX edit"
		
	| x |
	x := GCBizProcess bizOffer.
	^x idNumberPolicy: #GCDefaultNoPolicy;
	yourself.








! !

!GCSupplierBizProcess class methodsFor: 'asvo-supplier biz process' stamp: 'hk 2/16/2016 14:25'!
supplierBizOrder
	"self supplierBizOrderX edit"
		
	| x |
	x := GCBizProcess bizOrder.
	^x idNumberPolicy: #GCDefaultNoPolicy;
	yourself.










! !

!GCSupplierBizProcess class methodsFor: 'asvo-supplier biz process' stamp: 'hk 5/2/2017 16:47'!
supplierBizProcess
	"self supplierBizProcess editD"
		
	^GbtSmartThing struct: 'GCSupplierBizProcess' define: {
		{ #purposes .   #(supplierBizProcess)}.
		{ #idNumberPolicy . #GCSupplierBizProcessNoPolicy }.
		{ #summary .  'BizId: #bizId'}.
		{ #supplierBizProcessHeader . #thing: . GCBizProcess bizProcessHeader }.
		{ #supplierBizProcessStatus . #thing: . GCBizProcess aspectStatus purpose: #supplierBizProcess }.
		{ #supplierBizSubProcesses . #listOf: . self supplierBizSubProcess }.	
	} full: { 
		{ #bizCustomerForSupplier . #thing: . GCBizProcess bizCustomer }. 
		{ #supplierServiceData . #thing: . GCServiceData serviceData }.
		{ #supplierBizProcessNotes . #listOf: . GCBizProcess aspectNote}.	
	 }! !

!GCSupplierBizProcess class methodsFor: 'asvo-supplier biz process' stamp: 'hk 3/3/2016 14:29'!
supplierBizRequest
	"self supplierBizRequest editD"
		
	^GCBizProcess bizRequest	
		idNumberPolicy: #GCDefaultNoPolicy;
		yourself.











! !

!GCSupplierBizProcess class methodsFor: 'asvo-supplier biz process' stamp: 'hk 5/2/2017 16:47'!
supplierBizSubProcess
	"self supplierBizSubProcess edit"
		
		
	^GbtSmartThing struct: 'GCSupplierBizSubProcess' define: { 
		{ #purposes . #(supplierBizSubProcess) }.
		{ #idNumberPolicy . #GCSupplierBizSubProcessNoPolicy }.
		{ #summary . '#bizId #supplierBizSubProcessStatus #bizSupplier #supplierBizRequest'}.
		{ #supplierBizSubProcessHeader . #thing: . GCBizProcess bizProcessHeader }.
		{ #supplierBizProcessId . #val: . '' }.
	} full: { 
		{ #supplierBizSubProcessStatus . #thing: . GCBizProcess aspectStatus purpose: #SupplierBizSubProcess}.
		{ #bizCustomer . #thing: . GCContact contact }. 
		{ #bizSupplier . #thing: . GCContact contact }. 
		{ #supplierSubProcessServiceData . #thing: . GCServiceData serviceData }.
		{ #supplierBizRequest . #thing: . self supplierBizRequest }.
		{ #supplierBizOffer . #thing: . self supplierBizOffer }.		
		{ #supplierBizOrder . #thing: . self supplierBizOrder}.
"		{ #supplierBizOrderAcknowledgment . #thing: . self bizOrderAcknowledgementX }."
"		{ #supplierBizInvoices . #thing: . self bizInvoicesX }.	"		
"		{ #supplierBizNetRequest . #thing: . self bizNetRequestX }.
		{ #supplierBizNetOffer . #thing: . self bizNetOfferX }.	
		{ #supplierBizNetOrder . #thing: . self bizNetOrderX }.			"
"		{ #supplierBizNetOrderAcknowledgement . #thing: . self bizNetOrderAcknowledgmentX }.
		{ #supplierBizNetInvoices . #thing: . self bizNetInvicesX }.			"
		{ #supplierBizSubProcessNotes . #listOf: . GCBizProcess aspectNote}.									
	} ! !

GCTasks subclass: #GCTourDispatch
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GBT-DSL_GC_Things'!
